unit e_Karkulka;

interface
uses
   Elements;

type
   TKarkulka_MapRegElement = Class(TOwnerEntity)
  private
    Fcf: integer;
    FMapID: string;
    FMapName: string;
    FProject: string;
    Fuser: string;
    FSubject: string;
    FPlocha: integer;
    FMapDir: string;
    procedure Setcf(const Value: integer);
    procedure SetMapID(const Value: string);
    procedure SetMapName(const Value: string);
    procedure SetProject(const Value: string);
    procedure SetSubject(const Value: string);
    procedure Setuser(const Value: string);
    procedure SetPlocha(const Value: integer);
    procedure SetMapDir(const Value: string);
   published
      property MapID: string read FMapID write SetMapID;
      property MapName: string read FMapName write SetMapName;
      property MapDir: string read FMapDir write SetMapDir;
      property Subject: string read FSubject write SetSubject;
      property Project: string read FProject write SetProject;
      property user: string read Fuser write Setuser;
      property Plocha: integer read FPlocha write SetPlocha;
      property cf: integer read Fcf write Setcf;
   end;

implementation
uses
   e_Class;

{ TKarkulka_MapRegElement }

procedure TKarkulka_MapRegElement.Setcf(const Value: integer);
begin
  Fcf := Value;
end;

procedure TKarkulka_MapRegElement.SetMapDir(const Value: string);
begin
  FMapDir := Value;
end;

procedure TKarkulka_MapRegElement.SetMapID(const Value: string);
begin
  FMapID := Value;
end;

procedure TKarkulka_MapRegElement.SetMapName(const Value: string);
begin
  FMapName := Value;
end;

procedure TKarkulka_MapRegElement.SetPlocha(const Value: integer);
begin
  FPlocha := Value;
end;

procedure TKarkulka_MapRegElement.SetProject(const Value: string);
begin
  FProject := Value;
end;

procedure TKarkulka_MapRegElement.SetSubject(const Value: string);
begin
  FSubject := Value;
end;

procedure TKarkulka_MapRegElement.Setuser(const Value: string);
begin
  Fuser := Value;
end;

initialization
   RegisterOrbisClass(TKarkulka_MapRegElement);
end.
 