unit t_GIs_Note_Dialog;

interface
uses
   e_GeometryEx,
   f_Gis_Note_Dialog,
   t_OrbisDialog;

type

TGis_NoteDialog = class(TOrbisDialog)
  private
    function GetForm: TGis_NoteDialog_Form;
    function GetNote: TGis_Note;
public
   property  Note: TGis_Note read GetNote;
   procedure DoIt; override;
   procedure CreateForm; override;
   property  Form: TGis_NoteDialog_Form read GetForm;
end;

implementation
uses
   Forms,
   e_Class;

{ TGis_NoteDialog }

procedure TGis_NoteDialog.CreateForm;
begin
   aForm := TGis_NoteDialog_Form.Create(Application);
   aForm.Tool := Self;
   aForm.IsPossibleToClose := false;
end;

procedure TGis_NoteDialog.DoIt;
begin
   if Input = nil  then exit;

   if not DontShowForm then
   begin
      Form.NewObject := NewObject;
      Form.Note := Note;
      inherited;
//      if Result = 1 then
//         Value_ := Form.ed_Value.Value;
   end;
   if DontShowForm or (Result = 1) then
   begin
   end;
end;

function TGis_NoteDialog.GetForm: TGis_NoteDialog_Form;
begin
   result := TGis_NoteDialog_Form(aForm);
end;

function TGis_NoteDialog.GetNote: TGis_Note;
begin
   result := TGis_Note(Input);
end;

INITIALIZATION
   RegisterOrbisClass(TGis_NoteDialog);
END.
