unit DataB;

INTERFACE

uses
  DBStream, DBType, DBStrUp,
  Objects,
  MSElems, Global;

type
  TAtribLink = record
     Slov         : byte;
     properties   : byte;   
     IdentDB      : word;
     cosi         : word;
     CisloDatabaze: word;
     MSLINK       : LongInt;
  end;


var

  RidiciDatabaze: String;
  AtribLink     : TAtribLink;
  JeRidiciDB    : Boolean;    { Existuje ridici databaze }
  DBOK          : Boolean;    { ridici DB je ve formatu DBF a v poradku }
  JeDB          : Boolean;    { Aktualni element ma databazi }
  PripojeneDB   : TCollection;
  PStrucDB      : TStruDBPtr; {TPolDBFPtr;}

  StartApp      : TStartApp;


function  UpCaseStr(St: String): String;
procedure VratJmenoRidiciDatabaze;
procedure HledejRidiciDatabazi;



IMPLEMENTATION
uses
  DOS, CRT;

function UpCaseStr(St: String): String;
  var
    i: Byte;
    Pom: String;
  begin
    Pom := St;
    for i := 1 to Length(Pom) do
    begin
       Pom[i] := UpCase(Pom[i]);
    end;
    UpCaseStr := Pom;
  end;


procedure VratJmenoRidiciDatabaze;
  var
     cc: Char;
     i : word;
  begin
     for i := 1 to 255 do
     begin
        if StartApp.Command[i] = #0 then Break;
        RidiciDatabaze[i] := StartApp.Command[i];
     end;
     RidiciDatabaze[0] :=Chr(i - 1);
  end;




procedure HledejRidiciDatabazi;
var
  KontrolW: word;
  PomSize: word;

  {LP}
  procedure UdelejSeznamDB;
  var
     DB: TDBStream;
     I : LongInt;
     Jm: String;
  begin
     FSplit(CestaDGN,D,Nm,E);
     PripojeneDB.Init(5,1);
     DB.Init(D+RidiciDatabaze, nil, false);
     DBOK := DB.OKInit and DB.OKSetBuf(MaxAvail div 2);
     if not DBOK then
     begin
        DB.Done;
        PripojeneDB.Done;
        Exit;
     end;
     if not DB.OKNastavPolJm('DATABASE') then
     begin
        DBOK := False;
        DB.Done;
        PripojeneDB.Done;
        Exit;
     end;
     if DB.OKNastavZazn(1) then
     begin
        repeat
           PripojeneDB.Insert(NewStr(DB.DejStavPolStr));
        until not DB.OKNastavDalsiZazn;
     end
     else begin
             DBOK := False;
             DB.Done;
             PripojeneDB.Done;
             Exit;
          end;
      DB.Done;
  end;


  {LP}
  procedure UdelejStrukturyDB;
  var
     VDB: TVytvStruDB;

     PPol: TStruDBPtr;
     i: longint;
     iStr: String;
     Poz: word;
  begin
     VDB.Init;
     VDB.PridejPol('CISLO', 'N', 6, 0);

     for i := 1 to PripojeneDB.Count do
     begin
        Str(i,iStr);
        VDB.PridejPol('MSL'+ iStr, 'N', 10, 0);
     end;

     PStrucDB:= DejKopiiDBPtr(VDB.DejStruPtr);
     VDB.Done
  end;




{MAIN} {HledejRidiciDatabazi}
begin
  GotoXY(3,18);
  Writeln('Hledam pripojene databaze');
  JeRidiciDB := False;
  DBOK   := False;
  Pozice := 0;
  Prvni  := True;
  while (True) do
  begin
     if Prvni then
     begin
        Prvni := False;
     end
     else begin
             Seek(F,Pozice + 4 + EHDR.Words shl 1);
             BlockRead(F,KontrolW,SizeOf(word));
             if KontrolW = EOD then exit;
             Seek(F,Pozice + 4 + EHDR.Words shl 1);
          end;
     Pozice := FilePos(F);
     BlockRead(F,EHDR,SizeOf(Elm_hdr));
     if Typ = MICROSTATION_ELM then
     begin
        if Level = 10 then
        begin
           PomSize := FileSize(F) - FilePos(F);
           if PomSize > SizeOf(TStartApp) then PomSize := SizeOf(TStartApp);

           BlockRead(F,StartApp,PomSize);
           VratJmenoRidiciDatabaze;
           if RidiciDatabaze <> '' then JeRidiciDB := True;
           FSplit(RidiciDatabaze,D,Nm,E);
           if (UpCaseStr(E) = '.DBF') or
              (UpCaseStr(E) = '.CTL') then DBOK := True;
           if DBOK then
           begin
              UdelejSeznamDB;
              UdelejStrukturyDB;
           end;
           exit;
        end;
     end;
  end;
end;

end.