unit E_map;
{****************************************************************************}
{                                                                            }
{          ORBIS MAPPER   ... Mapov prostor a Mapov list                   }
{                    (c) 1996                                                }
{                                                                            }
{****************************************************************************}
interface

uses
// KERNEL
   Elements,
// GLIB
   G_Elems,
// MAPPER   
   e_MTempl,
   e_SPTree,
   e_View;

type

TmapSheet = class(TMapSheetTemplate)
private
  FSaveStr: string;
  procedure SaveToFile(aName: string);
public
  function GetViewByName(aName: string): TView;
  function GetTextByName(aName: string): TText;
published
  property Save: string read FSaveStr write SaveToFile;
end;

TMapSheets = class(TOwnerEntity);


implementation
uses
  WinProcs,
// KERNEL
  e_Class;


function TmapSheet.GetViewByName(aName: string): TView;
begin
  result:= TView(FindElementName(aName));
  if not (TElement(result) is TView) then result:= nil
end;


function TmapSheet.GetTextByName(aName: string): TText;
begin
  result:= TText(FindElementName(aName));
  if not (TElement(result) is TText) then result:= nil
end;


procedure TmapSheet.SaveToFile(aName: string);
begin
  MessageBeep(0);
  FSaveStr:= aName
end;


BEGIN
   RegisterOrbisClass(TMapSheet);

end.
