unit F_Guide;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Menus, Buttons, ExtCtrls,
// KERNEL
  Elements,
  Tools,
// DEVICE
  e_Device,
  t_Device;

type
  TGuideForm = class(TForm)
    MainMenu: TMainMenu;
    View: TMenuItem;
    Tools: TMenuItem;
    Prezobraz: TMenuItem;
    PrintDialog: TPrintDialog;
    PrinterSetupDialog: TPrinterSetupDialog;
    PopupMenu1: TPopupMenu;
    meritko: TMenuItem;
    All: TMenuItem;
    ToolBar: TPanel;
    Image: TImage;
    Model1: TMenuItem;
    b_50: TSpeedButton;
    b_10: TSpeedButton;
    b_5: TSpeedButton;
    b_Texty: TSpeedButton;
    b_Fill: TSpeedButton;
    Panel1: TPanel;
    BitBtn1: TBitBtn;
    BitBtn3: TBitBtn;
    Prvodce1: TMenuItem;
    Vytvoen1: TMenuItem;
    N2: TMenuItem;
    Nastaventiskrny1: TMenuItem;
    Tisk1: TMenuItem;
    b_Viewer: TSpeedButton;
    b_GuideSelector: TSpeedButton;
    N3: TMenuItem;
    Panel2: TPanel;
    Bevel1: TBevel;
    Bevel2: TBevel;
    Bevel3: TBevel;
    l_50: TLabel;
    l_10: TLabel;
    l_5: TLabel;
    Vezdlevbru1: TMenuItem;
    Odstranitvybran1: TMenuItem;
    Inverzevbru1: TMenuItem;
    b_NewUserSpace: TSpeedButton;
    b_EditUserSpace: TSpeedButton;
    Panel3: TPanel;
    b_Size: TSpeedButton;
    Label1: TLabel;
    l_x: TLabel;
    Bevel7: TBevel;
    Label2: TLabel;
    l_y: TLabel;
    Bevel8: TBevel;
    b_U: TSpeedButton;
    BitBtn2: TBitBtn;
    Oteven1: TMenuItem;
    Uloendosouboru1: TMenuItem;
    N4: TMenuItem;
    Importvektorovkresby1: TMenuItem;
    Pezobrazit1: TMenuItem;
    Vezdlevektorovkresby1: TMenuItem;
    OpenDialog: TOpenDialog;
    SaveDialog: TSaveDialog;
    N1: TMenuItem;
    Struktura1: TMenuItem;
    Label3: TLabel;
    Bevel5: TBevel;
    l_M: TLabel;
    b_25: TSpeedButton;
    Bevel4: TBevel;
    l_25: TLabel;
    b_2: TSpeedButton;
    b_MakeDetail: TSpeedButton;
    Bevel6: TBevel;
    l_2: TLabel;
    b_ZM: TSpeedButton;
    SpeedButton1: TSpeedButton;
    procedure PrezobrazClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure SouradniceClick(Sender: TObject);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormResize(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure meritkoClick(Sender: TObject);
    procedure AllClick(Sender: TObject);
    procedure btn_LinkDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure Skk1Click(Sender: TObject);
    procedure Nahoe1Click(Sender: TObject);
    procedure Dole1Click(Sender: TObject);
    procedure Vlevo1Click(Sender: TObject);
    procedure Vpravo1Click(Sender: TObject);
    procedure Plovouc1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure b_50Click(Sender: TObject);
    procedure b_10Click(Sender: TObject);
    procedure b_5Click(Sender: TObject);
    procedure b_TextyClick(Sender: TObject);
    procedure b_FillClick(Sender: TObject);
    procedure Nastaventiskrny1Click(Sender: TObject);
    procedure Tisk1Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure AutomatickypodlerastruClick(Sender: TObject);
    procedure Manuln1Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Model1Click(Sender: TObject);
    procedure b_ViewerClick(Sender: TObject);
    procedure b_GuideSelectorClick(Sender: TObject);
    procedure Vezdlevbru1Click(Sender: TObject);
    procedure Odstranitvybran1Click(Sender: TObject);
    procedure b_NewUserSpaceClick(Sender: TObject);
    procedure b_EditUserSpaceClick(Sender: TObject);
    procedure b_SizeClick(Sender: TObject);
    procedure Importvektorovkresby1Click(Sender: TObject);
    procedure Oteven1Click(Sender: TObject);
    procedure Uloendosouboru1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure b_UClick(Sender: TObject);
    procedure Inverzevbru1Click(Sender: TObject);
    procedure Vezdlevektorovkresby1Click(Sender: TObject);
    procedure Pezobrazit1Click(Sender: TObject);
    procedure Struktura1Click(Sender: TObject);
    procedure b_25Click(Sender: TObject);
    procedure cbMakeDetailClick(Sender: TObject);
    procedure b_2Click(Sender: TObject);
    procedure b_MakeDetailClick(Sender: TObject);
    procedure b_ZMClick(Sender: TObject);
    procedure b_ZMMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SpeedButton1Click(Sender: TObject);
    procedure FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
  private
    IsActive: boolean;
    IsPickUpMode: boolean;
    {
    ShiftRect: TRect;
    }
  public
    IsPossibleToClose: boolean;
    Tool: TDeviceTool;
  end;


implementation
uses
  IniFiles,
// KERNEL
  M_Orbis,
  Worlds,
//
  M_Proj,
  e_Desktp,
  e_Guide,
  e_View,
  f_SetScl,
  f_ZMDialog,
  g_Elems,
  i_Guide,
  t_Guide,
  t_MainTl,
  t_Recurs,
  t_SelG;

{$R *.DFM}


procedure TGuideForm.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  if IsPossibleToClose then
  begin
     CanClose:= true;
  end
  else
  begin
    CanClose:= false;

    IsPossibleToClose := true;
    Tool.PostMsg(tm_Pruvodce, World.MainTool, nil, DontKill);

  end
end;




procedure TGuideForm.PrezobrazClick(Sender: TObject);
begin
  Tool.PostMsg(tm_ReView, Tool, nil, DontKill);
end;


procedure TGuideForm.SouradniceClick(Sender: TObject);
begin
  {
  Post(tm_AddCoordsView, 0)
  }
end;

procedure TGuideForm.FormMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
   {
   if IsActive then
   }
   begin
      Tool.PostMouseEvent(tm_MouseMove, Tool, mbLeft, Shift, X, Y, IsActive);
   end;
end;

procedure TGuideForm.FormCreate(Sender: TObject);
var
   Ini: TIniFile;
begin
   IsPossibleToClose := false;
   IsActive := true;
   try
      //if TOldMainTool(World.MainTool).NoProject then AutomatickyPodleRastru.Enabled := false;
      Ini := TIniFile.Create(World.MainTool.GetPropertyStringByName('IniFile30'));
      //Ini := TIniFile.Create(IniFileName);
      Left        := Ini.ReadInteger('GuideForm','Left', 0);
      Top         := Ini.ReadInteger('GuideForm','Top', 0);
      Height      := Ini.ReadInteger('GuideForm','Height', 200);
      Width       := Ini.ReadInteger('GuideForm','Width', 200);
      b_U.Down    := Ini.ReadBool('GuideForm','U', false);
      b_2.Down    := Ini.ReadBool('GuideForm','2', false);
      b_5.Down    := Ini.ReadBool('GuideForm','5', true);
      b_10.Down   := Ini.ReadBool('GuideForm','10',false);
      b_25.Down   := Ini.ReadBool('GuideForm','25',false);
      b_50.Down   := Ini.ReadBool('GuideForm','50',false);
      b_Texty.Down:= Ini.ReadBool('GuideForm','Texty',true);
      b_Fill.Down := Ini.ReadBool('GuideForm','Fill',true);
      Ini.Free;
   except
   end;
end;

procedure TGuideForm.FormMouseDown(Sender: TObject;
   Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
   begin
      Tool.PostMouseEvent(tm_MouseDown, Tool, Button, Shift, X, Y, IsActive);
   end;
end;

procedure TGuideForm.FormMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
   R: TDoubleRect;
   aTool: TTool;
begin
    begin
      Tool.PostMouseEvent(tm_MouseUp, Tool, Button, Shift, X, Y, IsActive);
    end;
    IsActive := true;
end;



procedure TGuideForm.FormMouseWheelDown(Sender: TObject; Shift: TShiftState; MousePos: TPoint; var Handled: Boolean);
var
   P: TPoint;
begin
    Handled := true;
    P := Image.ScreenToClient(MousePos);
    TDeviceTool(Tool).PostMouseEvent(tm_MouseWheelDown, Tool, mbMiddle, Shift, P.X, P.Y, IsActive);
end;

procedure TGuideForm.FormMouseWheelUp(Sender: TObject; Shift: TShiftState; MousePos: TPoint; var Handled: Boolean);
var
   P: TPoint;
begin
    Handled := true;
    P := Image.ScreenToClient(MousePos);
    TDeviceTool(Tool).PostMouseEvent(tm_MouseWheelUp, Tool, mbMiddle, Shift, P.X, P.Y, IsActive);
end;

procedure TGuideForm.FormResize(Sender: TObject);
begin
   try
      if not Visible then exit;
      Image.Picture.Bitmap.Height:= Image.Height;
      Image.Picture.Bitmap.Width:= Image.Width;
      if Tool = nil then exit;
      Tool.PostMsg(tm_ReSize, Tool, nil, DontKill);
      Application.ProcessMessages;
      {
      Tool.Device.SetupPage(nil);
      Tool.PostMsg(tm_ReView, Tool, nil, DontKill);
      }
   except
   end;
end;


procedure TGuideForm.FormDeactivate(Sender: TObject);
begin
   {
   TCanvasToBMPDevice(Tool.Device).Background := true;
   }
   IsActive := false;
end;

procedure TGuideForm.meritkoClick(Sender: TObject);
begin
  Tool.PostMsg(tm_NewScale, Tool, nil, DontKill);
end;

procedure TGuideForm.AllClick(Sender: TObject);
begin
  Tool.PostMsg(tm_ShowAll, Tool, nil, DontKill);
end;



procedure TGuideForm.btn_LinkDragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
begin
   (*
   if (Sender <> Source) then
   begin
      if (Source is TWorldOutline) then
         Tf_WorldView(TWorldOutline(Source).Owner).DragObject := Self;
      accept := true;
   end
   else *)accept := false;
end;



procedure TGuideForm.Skk1Click(Sender: TObject);
begin
  {
  if Skk1.Checked then
     Tool.Post(tm_ZobrazSitKrizku, Tool, nil)
  else
     Post(tm_ZobrazSitKrizku, 1);

  Skk1.Checked:= not SKK1.Checked
  }
end;

procedure TGuideForm.Nahoe1Click(Sender: TObject);
begin
   ToolBar.Align := alTop;
end;

procedure TGuideForm.Dole1Click(Sender: TObject);
begin
   ToolBar.Align := alBottom;
end;

procedure TGuideForm.Vlevo1Click(Sender: TObject);
begin
   ToolBar.Align := alLeft;
end;

procedure TGuideForm.Vpravo1Click(Sender: TObject);
begin
   ToolBar.Align := alRight;
end;

procedure TGuideForm.Plovouc1Click(Sender: TObject);
begin
   ToolBar.Align := alNone;
end;

procedure TGuideForm.FormActivate(Sender: TObject);
begin
   {
   TCanvasToBMPDevice(Tool.Device).BackGround := false;
   }
end;


procedure TGuideForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
   Tool.PostKeyEvent(tm_KeyDown, Tool, Key, Shift);
end;

procedure TGuideForm.b_50Click(Sender: TObject);
var
   GI: TGuideInterpret;
begin
   GI := TGuideInterpret(TGuideFormTool(Tool).Interpret);
   GI.Show_50 := not GI.Show_50;
   b_50.Down  := GI.Show_50;
   Tool.PostMsg(tm_ReView, Tool, nil, DontKill);
   Tool.PostMsg(tm_MapSpaceTouched, World.MainTool, nil, DontKill);
end;

procedure TGuideForm.b_10Click(Sender: TObject);
var
   GI: TGuideInterpret;
   S: TGuideSelector;
begin
   GI := TGuideInterpret(TGuideFormTool(Tool).Interpret);
   try
      GI.Show_10 := not GI.Show_10;
      b_10.Down  := GI.Show_10;
      S := TGuideSelector(TGuideFormTool(Tool).Tools.FindElementClass(TGuideSelector));
      S.SelectU := b_U.Down;
      S.Select10 := b_10.Down;
      S.Select5 := b_5.Down;
      S.Select2 := b_2.Down;
   except
   end;
   Tool.PostMsg(tm_ReView, Tool, nil, DontKill);
   Tool.PostMsg(tm_MapSpaceTouched, World.MainTool, nil, DontKill);
end;

procedure TGuideForm.b_5Click(Sender: TObject);
var
   GI: TGuideInterpret;
   S: TGuideSelector;
begin
   GI := TGuideInterpret(TGuideFormTool(Tool).Interpret);
   try
      GI.Show_5 := not GI.Show_5;
      b_5.Down  := GI.Show_5;
      S := TGuideSelector(TGuideFormTool(Tool).Tools.FindElementClass(TGuideSelector));
      S.SelectU := b_U.Down;
      S.Select10 := b_10.Down;
      S.Select5 := b_5.Down;
      S.Select2 := b_2.Down;
   except
   end;
   Tool.PostMsg(tm_ReView, Tool, nil, DontKill);
   Tool.PostMsg(tm_MapSpaceTouched, World.MainTool, nil, DontKill);
end;

procedure TGuideForm.b_TextyClick(Sender: TObject);
var
   GI: TGuideInterpret;
begin
   GI := TGuideInterpret(TGuideFormTool(Tool).Interpret);
   GI.Show_Text := not GI.Show_Text;
   b_Texty.Down  := GI.Show_Text;
   Tool.PostMsg(tm_ReView, Tool, nil, DontKill);
end;

procedure TGuideForm.b_FillClick(Sender: TObject);
var
   GI: TGuideInterpret;
begin
   GI := TGuideInterpret(TGuideFormTool(Tool).Interpret);
   GI.Fill_Page := not GI.Fill_Page;
   b_Fill.Down  := GI.Fill_Page;
   Tool.PostMsg(tm_ReView, Tool, nil, DontKill);
end;

procedure TGuideForm.Nastaventiskrny1Click(Sender: TObject);
begin
  PrinterSetupDialog.Execute
end;

procedure TGuideForm.Tisk1Click(Sender: TObject);
begin
//  Tool.PostMsg(tm_PrintForm, Tool, nil, DontKill);
end;

procedure TGuideForm.BitBtn1Click(Sender: TObject);
begin
   Tool.PostMsg(tm_GuideOK, Tool, nil, DontKill);
end;

procedure TGuideForm.AutomatickypodlerastruClick(Sender: TObject);
begin
   Tool.PostMsg(tm_CreateGuideAuto, Tool, nil, DontKill);
end;

procedure TGuideForm.Manuln1Click(Sender: TObject);
begin
   Tool.PostMsg(tm_CreateGuideMan, Tool, nil, DontKill);
end;

procedure TGuideForm.BitBtn3Click(Sender: TObject);
begin
   Tool.PostMsg(tm_GuideCancel, Tool, nil, DontKill);
end;

procedure TGuideForm.FormDestroy(Sender: TObject);
var
   Ini: TIniFile;
begin
   try
      //Ini := TIniFile.Create(TOldMainTool(World.MainTool).IniFileName);
      Ini := TIniFile.Create(World.MainTool.GetPropertyStringByName('IniFile30'));

      Ini.WriteInteger('GuideForm','Left', Left);
      Ini.WriteInteger('GuideForm','Top', Top);
      Ini.WriteInteger('GuideForm','Height', Height);
      Ini.WriteInteger('GuideForm','Width', Width);
      Ini.WriteBool('GuideForm','U', b_U.Down);
      Ini.WriteBool('GuideForm','2', b_2.Down);
      Ini.WriteBool('GuideForm','5', b_5.Down);
      Ini.WriteBool('GuideForm','10',b_10.Down);
      Ini.WriteBool('GuideForm','25',b_25.Down);
      Ini.WriteBool('GuideForm','50',b_50.Down);
      Ini.WriteBool('GuideForm','Texty',b_Texty.Down);
      Ini.WriteBool('GuideForm','Fill',b_Fill.Down);
      Ini.Free;
   except
   end;
end;

procedure TGuideForm.Model1Click(Sender: TObject);
begin
   Tool.PostMsg(tm_Explore, World.MainTool, Tool.Input, DontKill);
end;

procedure TGuideForm.b_ViewerClick(Sender: TObject);
begin
   Tool.PostMsg(tm_Viewer, Tool, nil, DontKill);
end;

procedure TGuideForm.b_GuideSelectorClick(Sender: TObject);
begin
   Tool.PostMsg(tm_Selector, Tool, nil, DontKill);
end;

procedure TGuideForm.Vezdlevbru1Click(Sender: TObject);
begin
   Tool.PostMsg(tm_ViewBySelect, Tool, nil, DontKill);
end;

procedure TGuideForm.Odstranitvybran1Click(Sender: TObject);
begin
   Tool.PostMsg(tm_DeleteSelected, Tool, nil, DontKill);
end;

procedure TGuideForm.b_NewUserSpaceClick(Sender: TObject);
begin
   if (not b_U.Down) and (b_NewUserSpace.Down)then b_UClick(nil);
   Tool.PostMsg(tm_NewUserSpace, Tool, nil, DontKill);
end;

procedure TGuideForm.b_EditUserSpaceClick(Sender: TObject);
begin
   if (not b_U.Down) and (b_EditUserSpace.Down)then b_UClick(nil);
   Tool.PostMsg(tm_EditUserSpace, Tool, nil, DontKill);
end;

procedure TGuideForm.b_SizeClick(Sender: TObject);
begin
   if b_Size.Down then Tool.PostMsg(tm_SizePanelOn, Tool, nil, DontKill)
                  else Tool.PostMsg(tm_SizePanelOff, Tool, nil, DontKill);
end;

procedure TGuideForm.Importvektorovkresby1Click(Sender: TObject);
begin
   Tool.PostMsg(tm_ImportBlk,  Tool, nil, DontKill);
end;

procedure TGuideForm.Oteven1Click(Sender: TObject);
begin
   Tool.PostMsg(tm_Open,  Tool, nil, DontKill);
end;

procedure TGuideForm.Uloendosouboru1Click(Sender: TObject);
begin
   Tool.PostMsg(tm_SaveAs,  Tool, nil, DontKill);
end;

procedure TGuideForm.BitBtn2Click(Sender: TObject);
begin
   Tool.PostMsg(tm_ImportBlk,  Tool, nil, DontKill);
end;

procedure TGuideForm.b_UClick(Sender: TObject);
var
   GI: TGuideInterpret;
   S: TGuideSelector;
begin
   GI := TGuideInterpret(TGuideFormTool(Tool).Interpret);
   try
      GI.Show_U := not GI.Show_U;
      b_U.Down  := GI.Show_U;
      S := TGuideSelector(TGuideFormTool(Tool).Tools.FindElementClass(TGuideSelector));
      S.SelectU := b_U.Down;
      S.Select10 := b_10.Down;
      S.Select5 := b_5.Down;
      S.Select2 := b_2.Down;
   except
   end;
   Tool.PostMsg(tm_ReView, Tool, nil, DontKill);
   Tool.PostMsg(tm_MapSpaceTouched, World.MainTool, nil, DontKill);
end;


procedure TGuideForm.Inverzevbru1Click(Sender: TObject);
begin
   Tool.PostMsg(tm_InvertSelected, Tool, nil, DontKill);
end;

procedure TGuideForm.Vezdlevektorovkresby1Click(Sender: TObject);
begin
   Tool.PostMsg(tm_ViewByVectors, Tool, nil, DontKill);
end;

procedure TGuideForm.Pezobrazit1Click(Sender: TObject);
begin
   Tool.PostMsg(tm_ReView, Tool, nil, DontKill);
end;

procedure TGuideForm.Struktura1Click(Sender: TObject);
begin
   Tool.PostMsg(tm_Explore, World.MainTool, Tool, DontKill);
end;

procedure TGuideForm.b_25Click(Sender: TObject);
var
   GI: TGuideInterpret;
   S: TGuideSelector;
begin
   GI := TGuideInterpret(TGuideFormTool(Tool).Interpret);
   try
      GI.Show_25 := not GI.Show_25;
      b_25.Down  := GI.Show_25;
      S := TGuideSelector(TGuideFormTool(Tool).Tools.FindElementClass(TGuideSelector));
      if not assigned(S) then exit;
      S.SelectU := b_U.Down;
      S.Select50 := b_50.Down;
      S.Select25 := b_25.Down;
      S.Select10 := b_10.Down;
      S.Select5 := b_5.Down;
      S.Select2 := b_2.Down;
   except
   end;
   Tool.PostMsg(tm_ReView, Tool, nil, DontKill);
   Tool.PostMsg(tm_MapSpaceTouched, World.MainTool, nil, DontKill);
end;

procedure TGuideForm.cbMakeDetailClick(Sender: TObject);
var
   S: TGuideSelector;
begin
   {
   S := TGuideSelector(TGuideFormTool(Tool).Tools.FindElementClass(TGuideSelector));
   if not assigned(S) then exit;
   S.InfoSelect:= not cbMakeDetail.Checked
   }
end;

procedure TGuideForm.b_2Click(Sender: TObject);
var
   GI: TGuideInterpret;
   S: TGuideSelector;
begin
   GI := TGuideInterpret(TGuideFormTool(Tool).Interpret);
   try
      GI.Show_2:= not GI.Show_2;
      b_2.Down  := GI.Show_2;
      S := TGuideSelector(TGuideFormTool(Tool).Tools.FindElementClass(TGuideSelector));
      S.SelectU := b_U.Down;
      S.Select10 := b_10.Down;
      S.Select5 := b_5.Down;
      S.Select2 := b_2.Down;
   except
   end;
   Tool.PostMsg(tm_ReView, Tool, nil, DontKill);
   Tool.PostMsg(tm_MapSpaceTouched, World.MainTool, nil, DontKill);
end;

procedure TGuideForm.b_MakeDetailClick(Sender: TObject);
begin
   Tool.PostMsg(tm_Selector, Tool, Tool, DontKill);
end;

procedure TGuideForm.b_ZMClick(Sender: TObject);
var
   GI: TGuideInterpret;
   S: TGuideSelector;
begin
   GI := TGuideInterpret(TGuideFormTool(Tool).Interpret);
   try
      GI.Show_ZM:= not GI.Show_ZM;
      b_ZM.Down  := GI.Show_ZM;
      S := TGuideSelector(TGuideFormTool(Tool).Tools.FindElementClass(TGuideSelector));
      S.SelectU := b_U.Down;
      S.Select10 := b_10.Down;
      S.Select5 := b_5.Down;
      S.Select2 := b_2.Down;
      S.SelectZM := b_ZM.Down;
   except
   end;
   Tool.PostMsg(tm_ReView, Tool, nil, DontKill);
   Tool.PostMsg(tm_MapSpaceTouched, World.MainTool, nil, DontKill);
end;

procedure TGuideForm.b_ZMMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
   D: TZMDialog;
   G: TGuide;
begin
   if not (Button = mbRight) then exit;
   G := TGuide(TGuideFormTool(Tool).Guide);
   D := TZMDialog.Create(Application);
   Case G.ZM.Scale of
      200000: D.g_Scale.ItemIndex := 0;
      100000: D.g_Scale.ItemIndex := 1;
      50000:  D.g_Scale.ItemIndex := 2;
      25000:  D.g_Scale.ItemIndex := 3;
   else
              D.g_Scale.ItemIndex := 4;
   end;
   D.ed_Color.Color := G.ZM.Color;
   D.ed_Width.Text := FormatFloat('0.00',G.ZM.PenWidth);
   D.ShowModal;
   if D.ModalResult = mrOk then
   begin
      case D.g_Scale.ItemIndex of
         0: G.ZM.Scale := 200000;
         1: G.ZM.Scale := 100000;
         2: G.ZM.Scale := 50000;
         3: G.ZM.Scale := 25000;
      else  G.ZM.Scale := 10000;
      end;
      G.ZM.Color := D.ed_Color.Color;
      try
         G.ZM.PenWidth := StrToFloat(D.ed_Width.Text);
      except
         G.ZM.PenWidth :=  0;
      end;
   end;
   D.Free;
end;


procedure TGuideForm.SpeedButton1Click(Sender: TObject);
begin
   Tool.PostTextMsg(tm_Run,'Mapper\Mapper30_GuideLines.oil',nil);
   Application.ProcessMessages;
end;

END.
