unit E_ShpReg;

interface
{$I ..\_conditions.inc}

uses
{$IFNDEF WIN64}
{$IFNDEF NOBDE}
  DBTables,
{$ENDIF}
{$ENDIF}
  DB,
// KERNEL
  Elements,
  e_Dataset,
  E_Type,
// SPACE
  E_Reg;



type


TShapeObjectOwner = class(TObjectOwner)
protected
  function  GetName: string; override;
end;


TShapeObjectRegister = class(TObjectRegister)
protected
  function CreateObjectOwner: TObjectOwner; override;
{ TODO -oO.S. -cZmeny pro ADO : 11.11.99 }
  function GetDBF: TDataSetElement; override;
end;


TShapeBlockRegister = class(TBlockRegister)
public
  function GetObjectRegister(aType: char): TObjectRegister; override;
end;







implementation
uses
  SysUtils, Forms,
  M_Orbis,
  e_Class,
  C_ShpDBF;






               { TShapeObjectOwner }


function  TShapeObjectOwner.GetName: string;
var
  CisloStr: string;
begin
  CisloStr:= GetPropertyStringByName('RecNo');
  result:= CisloStr
end;







                    { TTopolObjectRegister }



function TShapeObjectRegister.CreateObjectOwner;
begin
  result:= TShapeObjectOwner.Create;
end;



function TShapeObjectRegister.GetDBF: TDataSetElement;
begin
  result:= nil;
  if FDBF = nil then
  begin
    FDBF:= TShapeDBFTable.CreateWithOwner(Application);
    FDBF.ReadOnly:= true
  end;
  if FDBF = nil then exit;
  result:= FDBF;
end;



                  { TShapeBlockRegister }



function TShapeBlockRegister.GetObjectRegister(aType: char): TObjectRegister;
begin
  result:= TObjectRegister(FindElementName(aType));
  if result <> nil then exit;
  result:= TShapeObjectRegister.Create;
  result.Name:= aType;
  AddElement(result)
end;


initialization
   RegisterOrbisClass(TShapeObjectOwner);
   RegisterOrbisClass(TShapeObjectRegister);
   RegisterOrbisClass(TShapeBlockRegister);
end.
