{ D-}

{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
{XXX                                                             XXX}
{XXX    Copyright (c) - Help Service - Mapping, s.r.o.  1994     XXX}
{XXX                                                             XXX}
{XXX    Pouziti : - DosTopoL                                     XXX}
{XXX              - WinTopoL                                     XXX}
{XXX                                                             XXX}
{XXX                                                             XXX}
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}

{$N+,E+}
unit TrRasObM;


{&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&} interface {&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&}
{$IFDEF Windows}
uses
     StrProc, TranType, PakTrans, Header, MyStream, FuncType,
     TrRasObd;
{$ELSE}
uses dos,
     TranType, PakTrans, Header, MyStream,
     Procenta,
     RastObj,
     TrRasObd;
{$ENDIF}

{&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&}


procedure TransformujRastr2M(
{$IFDEF Windows}
                                   DalsiKrokAbortNMCallBackPr,
                                   BylUserAbortAbortNMCallBackPr,
                                   KeepWindowsAliveCallBackPr    : TFunctionDLL;
{$ENDIF}
                                   TransfPtr                : PTransformace;
                                   Sloupcu, Radku           : longInt;
{$IFDEF Windows}
                             const JmenoNovehoSouboru       : TPathStr;
{$ELSE}
                             const JmenoNovehoSouboru       : PathStr;
{$ENDIF}
                                   fSt                      : PPRStreamRas;
                                   Head                     : TypHeader;
                                   MinSSloupcuN, MaxSRadkuN,
                                   cSloupcuN, cRadkuN       : extended;
                                   SloupcuN, RadkuN         : longInt;
                             var   EscDone                  : boolean;
                                   GaussSystem              : boolean
{$IFNDEF Windows}
                                                                     ;
                                   Procenta                 : TProcentaPtr
{$ENDIF}
                                                                          );

{$IFDEF Windows}
export;
{$ENDIF}

procedure TransformujRastr256M(
{$IFDEF Windows}
                                     DalsiKrokAbortNMCallBackPr,
                                     BylUserAbortAbortNMCallBackPr,
                                     KeepWindowsAliveCallBackPr    : TFunctionDLL;
{$ENDIF}
                                     TransfPtr                : PTransformace;
                                     Sloupcu, Radku           : longInt;
{$IFDEF Windows}
                               const JmenoNovehoSouboru       : TPathStr;
{$ELSE}
                               const JmenoNovehoSouboru       : PathStr;
{$ENDIF}
                                     fSt                      : PPRStreamRas;
                                     Head                     : TypHeader;
                                     MinSSloupcuN, MaxSRadkuN,
                                     cSloupcuN, cRadkuN       : extended;
                                     SloupcuN, RadkuN         : longInt;
                               var   EscDone                  : boolean;
                                     GaussSystem              : boolean
{$IFNDEF Windows}
                                                                     ;
                                     Procenta                 : TProcentaPtr
{$ENDIF}
                                                                          );
{$IFDEF Windows}
export;
{$ENDIF}


function ZkouskaAfin256TrueM(
                             TransfPtr                : PTransformace;
                             Sloupcu, Radku           : longInt;
                             MinSSloupcuN, MaxSRadkuN,
                             cSloupcuN, cRadkuN       : extended;
                             SloupcuN, RadkuN         : longInt;
                             a1, a2, a3, b1, b2,
                             b3, a1_1                 : extended) : boolean;

{$IFDEF Windows}
export;
{$ENDIF}

function ZkouskaAfin256FalseM(
                              TransfPtr                : PTransformace;
                              Sloupcu, Radku           : longInt;
                              MinSSloupcuN, MaxSRadkuN,
                              cSloupcuN, cRadkuN       : extended;
                              SloupcuN, RadkuN         : longInt;
                              a1, a2, a3, b1, b2,
                              b3, a1_1                 : extended) : boolean;

{$IFDEF Windows}
export;
{$ENDIF}
function ZkouskaAfin2TrueM(
                           TransfPtr                : PTransformace;
                           Sloupcu, Radku           : longInt;
                           MinSSloupcuN, MaxSRadkuN,
                           cSloupcuN, cRadkuN       : extended;
                           SloupcuN, RadkuN         : longInt;
                           a1, a2, a3, b1, b2,
                           b3, a1_1                 : extended) : boolean;

{$IFDEF Windows}
export;
{$ENDIF}
function ZkouskaAfin2FalseM(
                            TransfPtr                : PTransformace;
                            Sloupcu, Radku           : longInt;
                            MinSSloupcuN, MaxSRadkuN,
                            cSloupcuN, cRadkuN       : extended;
                            SloupcuN, RadkuN         : longInt;
                            a1, a2, a3, b1, b2,
                            b3, a1_1                 : extended) : boolean;

{$IFDEF Windows}
export;
{$ENDIF}

{&&&&&&&&&&&&&&&&&&&&&&&&&&&&&} implementation {&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&}

{$IFDEF Windows}
uses WinDos, WinProcs, Strings,
     PTranPoV, PTranPoR, MatProc, FilProc, KeyProc,
     RasGlob;
{$ELSE}
uses crt,
     TxSouhl, TxHlasky, TxVyber,
     PTranPoV, PTranPoR, StrProc, MatProc, FilProc, KeyProc,
     Hlasky, Dialog,
     RasGlob;
{$ENDIF}


{&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&}



procedure urci(
               var ObrazS;
               var ObrazN;
                   k,j   : integer); assembler;
asm
        PUSH DS
        LDS SI,OBRAZS
        MOV DX,K
        MOV BX,DX
        MOV CL,3
        SHR BX,CL
        ADD SI,BX
        SHL BX,CL
        XOR DX,BX
        MOV CL,DL
        MOV BL,128
        SHR BL,CL
        TEST DS:[SI],BL
        JNZ @@1
        LDS SI,OBRAZN
        MOV DX,J
        MOV BX,DX
        MOV CL,3
        SHR BX,CL
        ADD SI,BX
        SHL BX,CL
        XOR DX,BX
        MOV CL,DL
        MOV BL,128
        SHR BL,CL
        not bl
        AND BYTE PTR DS:[SI],BL
@@1:    POP DS

end;



procedure WindowLine(
                     var ObrazSt;
                     var ObrazNo;
                         PocatekSt, PocatekNo, Pocet: word) ; assembler;
asm
        PUSH DS
        LDS SI,OBRAZST
        CLD
        MOV DX,PocatekSt
        MOV BX,DX
        MOV CL,3
        SHR BX,CL
        ADD SI,BX
        SHL BX,CL
        XOR DX,BX
        MOV CL,DL
        MOV BL,128
        SHR BL,CL
        MOV AH,BL
        LES DI,OBRAZNO
        MOV DX,PocatekNo
        MOV BX,DX
        MOV CL,3
        SHR BX,CL
        ADD DI,BX
        SHL BX,CL
        XOR DX,BX
        MOV CL,DL
        MOV BH,128
        SHR BH,CL
        MOV CX,Pocet
        LODSB
@@2:    TEST AL,AH
        JNZ @@1
        MOV BL,BH
        NOT BL
        AND  BYTE PTR ES:[DI],BL
@@1:    SHR BH,1
        JNZ  @@4
        MOV BH,128
        INC DI
@@4:    SHR AH,1
        JNZ  @@3
        LODSB
        MOV AH,128
@@3:    LOOP @@2
        POP DS

END;



function UrciNatoceni(
                      TransfPtr                : PTransformace;
                      MinSSloupcuN, MaxSRadkuN,
                      CSloupcuN                : real;
                      SloupcuN                 : longInt): boolean;
var
  BodZdr, BodCil, BodPomCil: TranType.Bod;

begin
  with TransfPtr^ do
  begin
    BodZdr.X  := MinSSloupcuN + SloupcuN * CSloupcuN;
    BodZdr.Y  := MaxSRadkuN;
    InvTransformuj(BodZdr, BodPomCil);
    BodZdr.X  := MinSSloupcuN;
    InvTransformuj(BodZdr, BodCil);
    if BodCil.Y < BodPomCil.Y then
      UrciNatoceni := false
    else
      UrciNatoceni := true;
  end;
end;


function ZkouskaAfin256TrueM(
                             TransfPtr                : PTransformace;
                             Sloupcu, Radku           : longInt;
                             MinSSloupcuN, MaxSRadkuN,
                             cSloupcuN, cRadkuN       : extended;
                             SloupcuN, RadkuN         : longInt;
                             a1, a2, a3, b1, b2,
                             b3, a1_1                 : extended) : boolean;
label
  4, 5;

const
  Den = 8640000;

var
  h1, m1, s1, hund1,
  h2, m2, s2, hund2,
  h3, m3, s3, hund3 : Word;
  Doba1, Doba2, Time1, Time2, Time3: longInt;
  kSt, s, sp, j, p, q, r, k, l, sl, k_r: longint;
  BodCil, PomBodCil, BodZdr, PomBodZdr: TranType.Bod;
  dxC, dyC, bpom1, bpom2, bpom3, apom1, apom2, apom3: extended;
  Zapisovat: boolean;

begin
  with TransfPtr^ do
  begin
    BodZdr.Y := MaxSRadkuN;

    if b1 <> 0 then
      bpom1 := ((-ZdrojStred.Y + 0.5 - b3)/b1 + cSloupcuN + CilStred.X - MinSSloupcuN)/cSloupcuN;
    if a1_1 <> 0 then
    begin
      apom1 := ( -ZdrojStred.X + 0.5 - a3)/a1_1;
      apom2 := ( -ZdrojStred.X - 0.5 - a3)/a1_1;
    end;

    GetTime(h1, m1, s1, hund1);

    sl := -2147483640;

    BodZdr.X := MinSSloupcuN - cSloupcuN;
    InvTransformuj(BodZdr, PomBodCil);

    BodZdr.X := BodZdr.X + CSloupcuN;
    InvTransformuj(BodZdr, BodCil);

    dxC := BodCil.Y - PomBodCil.Y;
    dyC := BodCil.X - PomBodCil.X;

    PomBodZdr.Y := (BodZdr.Y - CilStred.Y);
    bpom3       := PomBodZdr.Y*b2;
    if a1_1 <> 0 then
      apom3     := PomBodZdr.Y*a2/a1_1;

    j := 0;
    repeat
      k := pred(round(      BodCil.X));
      l := succ(round(Radku-BodCil.Y));
      if sl <> l then
      begin
        if (l > 0) and (l <= Radku) then
          Zapisovat := true
        else
          Zapisovat := false;
        sl := l;
      end;

      PomBodZdr.X := BodZdr.X - CilStred.X;
      kSt         := round(BodCil.X);

      if b1 < 0 then
        p := trunc((l - bpom3)/(b1*cSloupcuN) + bpom1)
      else
        p := pred(SloupcuN);

      if a1_1 > 0 then
        q := trunc((- kSt + a1*PomBodZdr.X)/a1_1 + apom1 - apom3)
      else
        if a1_1 < 0 then
          q := trunc((- kSt + a1*PomBodZdr.X)/a1_1 + apom2 - apom3)
        else
          q := pred(SloupcuN - j);

      if p-j < q then
        r := succ(p-j)
      else
        r := succ(q);

      if r < 1 then
        r := 1;

      if r > SloupcuN - j then
        r := SloupcuN - j;

      k_r := k+r;

      if (k >= 0) and (k < Sloupcu) and (k_r < Sloupcu) then
      begin
        if Zapisovat then;
      end
      else
        if k < 0 then
        begin
          if k_r >= 0 then
          begin
            inc(j, -k);
            inc(r,  k);
            if r >= Sloupcu then
            begin
              if Zapisovat then;
              goto 5;
            end else
            begin
              BodCil.X := BodCil.X - k*dyC;
              BodCil.Y := BodCil.Y - k*dxC;
              BodZdr.X := BodZdr.X + k*cSloupcuN;
              if Zapisovat and (r > 0)  then;
            end;
          end;
        end else
        begin
          if k < Sloupcu then
            if Zapisovat then;
          goto 5;
        end;

      inc(j, r);
      BodCil.X := BodCil.X + r*dyC;
      BodCil.Y := BodCil.Y + r*dxC;
      BodZdr.X := BodZdr.X + r*cSloupcuN;
    until j >= pred(SloupcuN);

  5:GetTime(h2, m2, s2, hund2);

    sl := -2147483640;

    BodZdr.X := MinSSloupcuN - CSloupcuN;
    InvTransformuj(BodZdr, PomBodCil);

    BodZdr.X := BodZdr.X + CSloupcuN;
    InvTransformuj(BodZdr, BodCil);

    dxC := BodCil.Y - PomBodCil.Y;
    dyC := BodCil.X - PomBodCil.X;

    BodCil.X := PomBodCil.X - dyC;
    BodCil.Y := PomBodCil.Y - dxC;

    j := -1;
    repeat
      inc(j);
      if j = SloupcuN then goto 4;
      BodCil.X := BodCil.X + dyC;
      BodCil.Y := BodCil.Y + dxC;
      k := pred(round(      BodCil.X));
      l :=      round(Radku-BodCil.Y) ;
    until (k >= 0) and (k < Sloupcu) and (l > 0) and (l <= Radku);
    sp := j;

    sl := l;

    for j := succ(sp) to pred(SloupcuN) do
    begin
      BodCil.X := BodCil.X + dyC;
      BodCil.Y := BodCil.Y + dxC;
      k := pred(round(      BodCil.X));
      l :=      round(Radku-BodCil.Y) ;
      if (k < 0) or (k >= Sloupcu) or (l < 1) or (l > Radku) then
        goto 4
      else
      begin
        if sl <> l then
        begin
          sl := l;
        end;
      end;
    end;

  4:GetTime(h3, m3, s3, hund3);

  end;
  Time1 := longInt(h1)*3600*100 + longInt(m1)*60*100 + s1*100 + hund1;
  Time2 := longInt(h2)*3600*100 + longInt(m2)*60*100 + s2*100 + hund2;
  Time3 := longInt(h3)*3600*100 + longInt(m3)*60*100 + s3*100 + hund3;
  Doba1 := Time2 - Time1;
  Doba2 := Time3 - Time2;
  if Doba1 < 0 then
    Doba1 := Den+Doba1;
  if Doba2 < 0 then
    Doba2 := Den+Doba2;
(*
  if Doba1 < Doba2 then
    ZkouskaAfin256TrueM := true
  else
*)
    ZkouskaAfin256TrueM := false;
end;


function ZkouskaAfin256FalseM(
                              TransfPtr                : PTransformace;
                              Sloupcu, Radku           : longInt;
                              MinSSloupcuN, MaxSRadkuN,
                              cSloupcuN, cRadkuN       : extended;
                              SloupcuN, RadkuN         : longInt;
                              a1, a2, a3, b1, b2,
                              b3, a1_1                 : extended) : boolean;
label
  3, 6;

const
  Den = 8640000;

var
  h1, m1, s1, hund1,
  h2, m2, s2, hund2,
  h3, m3, s3, hund3 : Word;
  Doba1, Doba2, Time1, Time2, Time3: longInt;
  kSt, s, sp, j, p, q, r, k, l, sl, k_r: longint;
  BodCil, PomBodCil, BodZdr, PomBodZdr: TranType.Bod;
  dxC, dyC, bpom1, bpom2, bpom3, apom1, apom2, apom3: extended;
  Zapisovat: boolean;

begin
  with TransfPtr^ do
  begin
    BodZdr.Y := MaxSRadkuN;

    if b1 <> 0 then
      bpom1 := ((-ZdrojStred.Y + 0.5 - b3)/b1 + cSloupcuN + CilStred.X - MinSSloupcuN)/cSloupcuN;
    if a1_1 <> 0 then
    begin
      apom1 := ( -ZdrojStred.X + 0.5 - a3)/a1_1;
      apom2 := ( -ZdrojStred.X - 0.5 - a3)/a1_1;
    end;

    GetTime(h1, m1, s1, hund1);

    sl := -2147483640;

    BodZdr.X := MinSSloupcuN + SloupcuN*cSloupcuN;
    InvTransformuj(BodZdr, PomBodCil);

    BodZdr.X := BodZdr.X - cSloupcuN;
    InvTransformuj(BodZdr, BodCil);

    dxC := PomBodCil.Y - BodCil.Y;
    dyC := PomBodCil.X - BodCil.X;

    PomBodZdr.Y := BodZdr.Y - CilStred.Y;
    bpom3       := PomBodZdr.Y*b2;
    if a1_1 <> 0 then
      apom3       := PomBodZdr.Y*a2/a1_1;

    j := 1;
    repeat
      k := pred(round(      BodCil.X));
      l := succ(round(Radku-BodCil.Y));
      if sl <> l then
      begin
        if (l > 0) and (l <= Radku) then
          Zapisovat := true
        else
          Zapisovat := false;
        sl := l;
      end;

      PomBodZdr.X := BodZdr.X - CilStred.X;
      kSt         := round(BodCil.X);

      if b1 > 0 then
        p := trunc((l - bpom3)/(b1*cSloupcuN) + bpom1)
      else
        p := SloupcuN;

      if a1_1 > 0 then
        q := trunc((kSt - a1*PomBodZdr.X)/a1_1 + apom1 - apom3)
      else
        if a1_1 < 0 then
          q := trunc((kSt - a1*PomBodZdr.X)/a1_1 + apom2 - apom3)
        else
          q := SloupcuN - j;

      if p-j < q then
        r := succ(p-j)
      else
        r := succ(q);

      if r < 1 then
        r := 1;

      if r > succ(SloupcuN - j) then
        r := succ(SloupcuN - j);

      k_r := k-r;

      if (k >= 0) and (k < Sloupcu) and (k_r >= -1) then
      begin
        if Zapisovat then;
      end
      else
        if k >= Sloupcu then
        begin
          if succ(k_r) < Sloupcu then
          begin
            if pred(Sloupcu) - k_r < Sloupcu then
            begin
              if Zapisovat and (r > 0)  then;
            end else
            begin
              if Zapisovat then;
              goto 6;
            end;
          end;
        end else
        begin
          if k >= 0 then
            if Zapisovat then;
          goto 6;
        end;

      inc(j, r);
      BodCil.X := BodCil.X + r*dyC;
      BodCil.Y := BodCil.Y + r*dxC;
      BodZdr.X := BodZdr.X - r*cSloupcuN;
    until j >= SloupcuN;

  6:GetTime(h2, m2, s2, hund2);

    sl := -2147483640;

    BodZdr.X := MinSSloupcuN + pred(SloupcuN)*cSloupcuN;
    TransfPtr^.InvTransformuj(BodZdr, PomBodCil);

    BodZdr.X := BodZdr.X - CSloupcuN;
    TransfPtr^.InvTransformuj(BodZdr, BodCil);

    dxC := BodCil.Y - PomBodCil.Y;
    dyC := BodCil.X - PomBodCil.X;

    BodCil.X := PomBodCil.X - dyC;
    BodCil.Y := PomBodCil.Y - dxC;

    j := SloupcuN;
    repeat
      dec(j);
      if j = -1 then goto 3;
      BodCil.X := BodCil.X + dyC;
      BodCil.Y := BodCil.Y + dxC;
      k := pred(round(      BodCil.X));
      l :=      round(Radku-BodCil.Y) ;
    until (k >= 0) and (k < Sloupcu) and (l > 0) and (l <= Radku);

    sp := j;
    sl := l;

    for j := pred(sp) downto 0 do
    begin
      BodCil.X := BodCil.X + dyC;
      BodCil.Y := BodCil.Y + dxC;
      k := pred(round(      BodCil.X));
      l :=      round(Radku-BodCil.Y) ;
      if (k < 0) or (k >= Sloupcu) or (l < 1) or (l > Radku) then
        goto 3
      else
      begin
        if sl <> l then
        begin
          sl := l;
        end;
      end;
    end;

  3:GetTime(h3, m3, s3, hund3);

  end;
  Time1 := longInt(h1)*3600*100 + longInt(m1)*60*100 + s1*100 + hund1;
  Time2 := longInt(h2)*3600*100 + longInt(m2)*60*100 + s2*100 + hund2;
  Time3 := longInt(h3)*3600*100 + longInt(m3)*60*100 + s3*100 + hund3;
  Doba1 := Time2 - Time1;
  Doba2 := Time3 - Time2;
  if Doba1 < 0 then
    Doba1 := Den+Doba1;
  if Doba2 < 0 then
    Doba2 := Den+Doba2;
(*
  if Doba1 < Doba2 then
    ZkouskaAfin256FalseM := true
  else
*)
    ZkouskaAfin256FalseM := false;
end;




function ZkouskaAfin2TrueM(
                           TransfPtr                : PTransformace;
                           Sloupcu, Radku           : longInt;
                           MinSSloupcuN, MaxSRadkuN,
                           cSloupcuN, cRadkuN       : extended;
                           SloupcuN, RadkuN         : longInt;
                           a1, a2, a3, b1, b2,
                           b3, a1_1                 : extended) : boolean;
label
  4, 5;

const
  Den = 8640000;

var
  h1, m1, s1, hund1,
  h2, m2, s2, hund2,
  h3, m3, s3, hund3 : Word;
  Doba1, Doba2, Time1, Time2, Time3: longInt;
  lSt, s, sp, j, p, q, r, k, l, sl, k_r: longint;
  BodCil, PomBodCil, BodZdr, PomBodZdr: TranType.Bod;
  dxC, dyC, bpom1, bpom2, bpom3, apom1, apom2, apom3: extended;
  Zapisovat: boolean;

begin
  with TransfPtr^ do
  begin
    BodZdr.Y := MaxSRadkuN;

    if b1 <> 0 then
      bpom1 := ((-ZdrojStred.Y + 0.5 - b3)/b1 + cSloupcuN + CilStred.X - MinSSloupcuN)/cSloupcuN;
    if a1_1 <> 0 then
    begin
      apom1 := ( -ZdrojStred.X + 0.5 - a3)/a1_1;
      apom2 := ( -ZdrojStred.X - 0.5 - a3)/a1_1;
    end;

    GetTime(h1, m1, s1, hund1);

    sl := -2147483640;

    BodZdr.X := MinSSloupcuN - cSloupcuN;
    InvTransformuj(BodZdr, PomBodCil);

    BodZdr.X := BodZdr.X + cSloupcuN;
    InvTransformuj(BodZdr, BodCil);

    dxC := PomBodCil.Y - BodCil.Y;
    dyC := PomBodCil.X - BodCil.X;

    PomBodZdr.Y := (BodZdr.Y - CilStred.Y);
    bpom3       := PomBodZdr.Y*b2;
    if a1_1 <> 0 then
      apom3     := PomBodZdr.Y*a2/a1_1;

    j := 0;
    repeat
      k := pred(round(      BodCil.X));
      l :=      round(Radku-BodCil.Y);
      if sl <> l then
      begin
        if (l >= 0) and (l < Radku) then
          Zapisovat := true
        else
          Zapisovat := false;
        sl := l;
      end;

      PomBodZdr.X := BodZdr.X - CilStred.X;
      lSt         := round(BodCil.Y);

      if b1 < 0 then
        p := trunc(SloupcuN - ((lSt - bpom3)/(b1*cSloupcuN) + bpom1))
      else
        p := pred(SloupcuN);

      if a1_1 > 0 then
        q := trunc((succ(k) - a1*PomBodZdr.X)/a1_1 + apom1 - apom3)
      else
        if a1_1 < 0 then
          q := trunc((succ(k) - a1*PomBodZdr.X)/a1_1 + apom2 - apom3)
        else
          q := pred(SloupcuN - j);

      if p-j < q then
        r := succ(p-j)
      else
        r := succ(q);

      if r < 1 then
        r := 1;

      if r > SloupcuN - j then
        r := SloupcuN - j;

      k_r := k+r;

      if (k >= 0) and (k < Sloupcu) and (k_r < Sloupcu) then
      begin
        if Zapisovat then;
      end
      else
        if k < 0 then
        begin
          if k_r >= 0 then
          begin
            inc(j, -k);
            inc(r,  k);
            if r >= Sloupcu then
            begin
              if Zapisovat then;
              goto 5;
            end else
            begin
              BodCil.X := BodCil.X - k*dyC;
              BodCil.Y := BodCil.Y - k*dxC;
              BodZdr.X := BodZdr.X + k*cSloupcuN;
              if Zapisovat and (r > 0)  then;
            end;
          end;
        end else
        begin
          if k < Sloupcu then
            if Zapisovat then;
          goto 5;
        end;

      inc(j, r);
      BodCil.X := BodCil.X + r*dyC;
      BodCil.Y := BodCil.Y + r*dxC;
      BodZdr.X := BodZdr.X - r*cSloupcuN;
    until j >= pred(SloupcuN);

  5:GetTime(h2, m2, s2, hund2);

    sl := -2147483640;

    BodZdr.X := MinSSloupcuN - CSloupcuN;
    InvTransformuj(BodZdr, PomBodCil);

    BodZdr.X := BodZdr.X + CSloupcuN;
    InvTransformuj(BodZdr, BodCil);

    dxC := BodCil.Y - PomBodCil.Y;
    dyC := BodCil.X - PomBodCil.X;

    BodCil.X := PomBodCil.X - dyC;
    BodCil.Y := PomBodCil.Y - dxC;

    j := -1;
    repeat
      inc(j);
      if j = SloupcuN then goto 4;
      BodCil.X := BodCil.X + dyC;
      BodCil.Y := BodCil.Y + dxC;
      k := pred(round(      BodCil.X));
      l :=      round(Radku-BodCil.Y) ;
    until (k >= 0) and (k < Sloupcu) and (l > 0) and (l <= Radku);
    sp := j;

    if sl <> l then
    begin
      sl := l;
    end;

    for j := succ(sp) to pred(SloupcuN) do
    begin
      BodCil.X := BodCil.X + dyC;
      BodCil.Y := BodCil.Y + dxC;
      k := pred(round(      BodCil.X));
      l :=      round(Radku-BodCil.Y) ;
      if (k < 0) or (k >= Sloupcu) or (l < 1) or (l > Radku) then
        goto 4
      else
      begin
        if sl <> l then
        begin
          sl := l;
        end;
      end;
    end;

  4:GetTime(h3, m3, s3, hund3);

  end;
  Time1 := longInt(h1)*3600*100 + longInt(m1)*60*100 + s1*100 + hund1;
  Time2 := longInt(h2)*3600*100 + longInt(m2)*60*100 + s2*100 + hund2;
  Time3 := longInt(h3)*3600*100 + longInt(m3)*60*100 + s3*100 + hund3;
  Doba1 := Time2 - Time1;
  Doba2 := Time3 - Time2;
  if Doba1 < 0 then
    Doba1 := Den+Doba1;
  if Doba2 < 0 then
    Doba2 := Den+Doba2;
(*
  if Doba1 < Doba2 then
    ZkouskaAfin2TrueM := true
  else
*)
    ZkouskaAfin2TrueM := false;
end;


function ZkouskaAfin2FalseM(
                            TransfPtr                : PTransformace;
                            Sloupcu, Radku           : longInt;
                            MinSSloupcuN, MaxSRadkuN,
                            cSloupcuN, cRadkuN       : extended;
                            SloupcuN, RadkuN         : longInt;
                            a1, a2, a3, b1, b2,
                            b3, a1_1                 : extended) : boolean;
label
  3, 6;

const
  Den = 8640000;

var
  h1, m1, s1, hund1,
  h2, m2, s2, hund2,
  h3, m3, s3, hund3 : Word;
  Doba1, Doba2, Time1, Time2, Time3: longInt;
  lSt, s, sp, j, p, q, r, k, l, sl, k_r: longint;
  BodCil, PomBodCil, BodZdr, PomBodZdr: TranType.Bod;
  dxC, dyC, bpom1, bpom2, bpom3, apom1, apom2, apom3: extended;
  Zapisovat: boolean;

begin
  with TransfPtr^ do
  begin

    BodZdr.Y := MaxSRadkuN;

    if b1 <> 0 then
      bpom1 := ((-ZdrojStred.Y + 0.5 - b3)/b1 + cSloupcuN + CilStred.X - MinSSloupcuN)/cSloupcuN;
    if a1_1 <> 0 then
    begin
      apom1 := ( -ZdrojStred.X + 0.5 - a3)/a1_1;
      apom2 := ( -ZdrojStred.X - 0.5 - a3)/a1_1;
    end;

    GetTime(h1, m1, s1, hund1);

    sl := -2147483640;

    BodZdr.X := MinSSloupcuN + pred(SloupcuN)*cSloupcuN;
    InvTransformuj(BodZdr, BodCil);

    BodZdr.X := BodZdr.X - cSloupcuN;
    InvTransformuj(BodZdr, PomBodCil);
    BodZdr.X := BodZdr.X + cSloupcuN;

    dxC := PomBodCil.Y - BodCil.Y;
    dyC := PomBodCil.X - BodCil.X;

    PomBodZdr.Y := BodZdr.Y - CilStred.Y;
    bpom3       := PomBodZdr.Y*b2;
    if a1_1 <> 0 then
      apom3       := PomBodZdr.Y*a2/a1_1;

    j := 1;
    repeat
      k := pred(round(      BodCil.X));
      l :=      round(Radku-BodCil.Y);
      if sl <> l then
      begin
        if (l >= 0) and (l < Radku) then
          Zapisovat := true
        else
          Zapisovat := false;
        sl := l;
      end;

      PomBodZdr.X := BodZdr.X - CilStred.X;
      lSt         := round(BodCil.Y);

      if b1 > 0 then
        p := trunc((lSt - bpom3)/(b1*cSloupcuN) + bpom1)
      else
        p := SloupcuN;

      if a1_1 > 0 then
        q := trunc((succ(k) - a1*PomBodZdr.X)/a1_1 + apom1 - apom3)
      else
        if a1_1 < 0 then
          q := trunc((succ(k) - a1*PomBodZdr.X)/a1_1 + apom2 - apom3)
        else
          q := SloupcuN - j;

      if p-j < q then
        r := succ(p-j)
      else
        r := succ(q);

      if r < 1 then
        r := 1;

      if r > succ(SloupcuN - j) then
        r := succ(SloupcuN - j);

      k_r := k-r;

      if (k >= 0) and (k < Sloupcu) and (k_r >= -1) then
      begin
        if Zapisovat then;
      end
      else
        if k >= Sloupcu then
        begin
          if succ(k_r) < Sloupcu then
          begin
            if pred(Sloupcu) - k_r < Sloupcu then
            begin
              if Zapisovat and (r > 0)  then;
            end else
            begin
              if Zapisovat then;
              goto 6;
            end;
          end;
        end else
        begin
          if k >= 0 then
            if Zapisovat then;
          goto 6;
        end;

      inc(j, r);
      BodCil.X := BodCil.X + r*dyC;
      BodCil.Y := BodCil.Y + r*dxC;
      BodZdr.X := BodZdr.X + r*cSloupcuN;
    until j >= SloupcuN;

  6:GetTime(h2, m2, s2, hund2);

    sl := -2147483640;

    BodZdr.X := MinSSloupcuN + pred(SloupcuN)*cSloupcuN;
    InvTransformuj(BodZdr, PomBodCil);

    BodZdr.X := BodZdr.X - CSloupcuN;
    InvTransformuj(BodZdr, BodCil);

    dxC := BodCil.Y - PomBodCil.Y;
    dyC := BodCil.X - PomBodCil.X;

    BodCil.X := PomBodCil.X - dyC;
    BodCil.Y := PomBodCil.Y - dxC;

    j := SloupcuN;
    repeat
      dec(j);
      if j = -1 then goto 3;
      BodCil.X := BodCil.X + dyC;
      BodCil.Y := BodCil.Y + dxC;
      k := pred(round(      BodCil.X));
      l :=      round(Radku-BodCil.Y) ;
    until (k >= 0) and (k < Sloupcu) and (l > 0) and (l <= Radku);
    sp := j;

    if sl <> l then
    begin
      sl := l;
    end;

    for j := pred(sp) downto 0 do
    begin
      BodCil.X := BodCil.X + dyC;
      BodCil.Y := BodCil.Y + dxC;
      k := pred(round(      BodCil.X));
      l :=      round(Radku-BodCil.Y) ;
      if (k < 0) or (k >= Sloupcu) or (l < 1) or (l > Radku) then
        goto 3
      else
      begin
        if sl <> l then
        begin
          sl := l;
        end;
      end;
    end;

  3:GetTime(h3, m3, s3, hund3);

  end;
  Time1 := longInt(h1)*3600*100 + longInt(m1)*60*100 + s1*100 + hund1;
  Time2 := longInt(h2)*3600*100 + longInt(m2)*60*100 + s2*100 + hund2;
  Time3 := longInt(h3)*3600*100 + longInt(m3)*60*100 + s3*100 + hund3;
  Doba1 := Time2 - Time1;
  Doba2 := Time3 - Time2;
  if Doba1 < 0 then
    Doba1 := Den+Doba1;
  if Doba2 < 0 then
    Doba2 := Den+Doba2;
(*
  if Doba1 < Doba2 then
    ZkouskaAfin2FalseM := true
  else
*)
    ZkouskaAfin2FalseM := false;
end;










procedure Afin256TrueM(
{$IFDEF Windows}
                             DalsiKrokAbortNMCallBackPr,
                             BylUserAbortAbortNMCallBackPr,
                             KeepWindowsAliveCallBackPr    : TFunctionDLL;
{$ENDIF}
                             TransfPtr                : PTransformace;
                             Sloupcu, Radku           : longInt;
{$IFDEF Windows}
                       const JmenoNovehoSouboru       : TPathStr;
{$ELSE}
                       const JmenoNovehoSouboru       : PathStr;
{$ENDIF}
                             fSt                      : PPRStreamRas;
                             fN                       : PPWStream;
                             MinSSloupcuN, MaxSRadkuN,
                             cSloupcuN, cRadkuN       : extended;
                             SloupcuN, RadkuN         : longInt;
                       var   EscDone                  : boolean
{$IFNDEF Windows}
                                                             ;
                             Procenta                 : TProcentaPtr
{$ENDIF}
                                                                  );

label
  1, 2;

const
  eps = 1E-5;

var
  ObrazN, ObrazS: pointer;
  lSt, sp, i, j, p, q, r, k, l, sl, k_r: longint;
  BodCil, PomBodCil, BodZdr, PomBodZdr: TranType.Bod;
  dxC, dyC, a1, a2, a3, b1, b2, b3, a1_1,
  bpom1, bpom2, bpom3, apom1, apom2, apom3: extended;
  Zapisovat: boolean;
{$IFDEF Windows}
  Retezec1: array[0..255] of char;
{$ENDIF}

begin
  sl := -2147483640;

  with TransfPtr^ do
  begin
{$IFDEF Windows}
    LoadString(HInstance, 621, Retezec1, 256);
    if (StrIComp(TransfPtr^.NazevTransformace, Retezec1{'PODOBN 2D'}) = 0) then
{$ELSE}
    if NazevTransformace = Vyb_Podobn2D{'PODOBN 2D'} then
{$ENDIF}
    begin
      a1   :=  InvKlic[1];
      a2   := -InvKlic[2];
      a3   :=  0;
      b1   :=  InvKlic[2];
      b2   :=  InvKlic[1];
      b3   :=  0;
      a1_1 :=  1-a1*cSloupcuN;
    end else
    begin
      a1   := InvKlic[1];
      a2   := InvKlic[2];
      a3   := InvKlic[3];
      b1   := InvKlic[4];
      b2   := InvKlic[5];
      b3   := InvKlic[6];
      a1_1 := 1-a1*cSloupcuN;
    end;

    if abs(b1)   < eps then b1   := 0;
    if abs(a1_1) < eps then a1_1 := 0;

    if ZkouskaAfin256TrueM(TransfPtr, Sloupcu, Radku, MinSSloupcuN, MaxSRadkuN, cSloupcuN, cRadkuN,
                           SloupcuN, RadkuN,
                           a1, a2, a3, b1, b2, b3, a1_1) then
    begin
      BodZdr.Y := MaxSRadkuN + cRadkuN;

      if b1 <> 0 then
        bpom1 := ((-ZdrojStred.Y + 0.5 - b3)/b1 + cSloupcuN + CilStred.X - MinSSloupcuN)/cSloupcuN;
      if a1_1 <> 0 then
      begin
        apom1 := ( -ZdrojStred.X + 0.5 - a3)/a1_1;
        apom2 := ( -ZdrojStred.X - 0.5 - a3)/a1_1;
      end;

      for i := 1 to RadkuN do
      begin
        fN^.NastavRadPtr(ObrazN);
        if fN^.Status <> 0 then
        begin
          Dispose(fN, Done);
          exit;
        end;

        if fN^.Bits4 then
          FillChar(ObrazN^, SloupcuN, 0)
        else
          FillChar(ObrazN^, SloupcuN, 255);

        BodZdr.Y := BodZdr.Y - cRadkuN;
        BodZdr.X := MinSSloupcuN - cSloupcuN;
        InvTransformuj(BodZdr, PomBodCil);

        BodZdr.X := BodZdr.X + CSloupcuN;
        InvTransformuj(BodZdr, BodCil);

        dxC := PomBodCil.Y - BodCil.Y;
        dyC := PomBodCil.X - BodCil.X;

        PomBodZdr.Y := (BodZdr.Y - CilStred.Y);
        bpom3       := PomBodZdr.Y*b2;
        if a1_1 <> 0 then
          apom3     := PomBodZdr.Y*a2/a1_1;

        j := 0;
        repeat
          k := pred(round(      BodCil.X));
          l :=      round(Radku-BodCil.Y);
          if sl <> l then
          begin
            if (l >= 0) and (l < Radku) then
            begin
              Zapisovat := true;
              fSt^.Read(ObrazS,  l);
            end
            else
              Zapisovat := false;
            sl := l;
          end;

          PomBodZdr.X := BodZdr.X - CilStred.X;
          lSt         := round(BodCil.Y);

          if b1 < 0 then
            p := trunc(SloupcuN - ((lSt - bpom3)/(b1*cSloupcuN) + bpom1))
          else
            p := pred(SloupcuN);

          if a1_1 > 0 then
            q := trunc((succ(k) - a1*PomBodZdr.X)/a1_1 + apom1 - apom3)
          else
            if a1_1 < 0 then
              q := trunc((succ(k) - a1*PomBodZdr.X)/a1_1 + apom2 - apom3)
            else
              q := pred(SloupcuN - j);

          if p-j < q then
            r := succ(p-j)
          else
            r := succ(q);

          if r < 1 then
            r := 1;

          if r > SloupcuN - j then
            r := SloupcuN - j;

          k_r := k+r;

          if (k >= 0) and (k < Sloupcu) and (k_r < Sloupcu) then
          begin
            if Zapisovat then
              move(PBuffer0(ObrazS)^[k], PBuffer0(ObrazN)^[j], r)
          end
          else
            if k < 0 then
            begin
              if k_r >= 0 then
              begin
                inc(j, -k);
                inc(r,  k);
                if r >= Sloupcu then
                begin
                  if Zapisovat then
                    move(PBuffer0(ObrazS)^[0], PBuffer0(ObrazN)^[j], Sloupcu);
                  goto 1;
                end else
                begin
                  BodCil.X := BodCil.X - k*dyC;
                  BodCil.Y := BodCil.Y - k*dxC;
                  BodZdr.X := BodZdr.X + k*cSloupcuN;
                  if Zapisovat and (r > 0)  then
                    move(PBuffer0(ObrazS)^[0], PBuffer0(ObrazN)^[j], r);
                end;
              end;
            end else
            begin
              if k < Sloupcu then
                if Zapisovat then
                  move(PBuffer0(ObrazS)^[k], PBuffer0(ObrazN)^[j], succ(Sloupcu-k));
              goto 1;
            end;

          inc(j, r);
          BodCil.X := BodCil.X + r*dyC;
          BodCil.Y := BodCil.Y + r*dxC;
          BodZdr.X := BodZdr.X - r*cSloupcuN;
        until j >= pred(SloupcuN);
{$IFDEF Windows}
      1:DalsiKrokAbortNMCallBackPr(0, 0);
        KeepWindowsAliveCallBackPr(0, 0);
        if BylUserAbortAbortNMCallBackPr(0, 0) then
        begin
          Dispose(fN, Done);
(*          ZrusRastr(JmenoNovehoSouboru, false, false);*)
          EscDone := true;
          exit;
        end;
{$ELSE}
      1:if keyPressed then
          if ReadKey = Esc then
            if Souhlas(Sou_SkutecnePrerusitTransf) then
            begin
              Dispose(fN, Done);
              ZrusRastr(JmenoNovehoSouboru);
              EscDone := true;
              exit;
            end;
        if Procenta^.ProvedZmenu then
          Procenta^.Vypis;
{$ENDIF}
      end;
    end else
    begin
      BodZdr.Y := MaxSRadkuN + CRadkuN;
      for i := 1 to RadkuN do
      begin
        fN^.NastavRadPtr(ObrazN);
        if fN^.Status <> 0 then
        begin
          Dispose(fN, Done);
          exit;
        end;

        if fN^.Bits4 then
          FillChar(ObrazN^, SloupcuN, 0)
        else
          FillChar(ObrazN^, SloupcuN, 255);

        BodZdr.X := MinSSloupcuN - CSloupcuN;
        BodZdr.Y := BodZdr.Y - CRadkuN;
        InvTransformuj(BodZdr, PomBodCil);

        BodZdr.X := BodZdr.X + CSloupcuN;
        InvTransformuj(BodZdr, BodCil);

        dxC := BodCil.Y - PomBodCil.Y;
        dyC := BodCil.X - PomBodCil.X;

        BodCil.X := PomBodCil.X - dyC;
        BodCil.Y := PomBodCil.Y - dxC;

        j := -1;
        repeat
          inc(j);
          if j = SloupcuN then goto 2;
          BodCil.X := BodCil.X + dyC;
          BodCil.Y := BodCil.Y + dxC;
          k := pred(round(      BodCil.X));
          l :=      round(Radku-BodCil.Y) ;
        until (k >= 0) and (k < Sloupcu) and (l >= 0) and (l < Radku);
        sp := j;

        fSt^.Read(ObrazS, l);
        sl := l;
        PBuffer0(ObrazN)^[j] := PBuffer0(ObrazS)^[k];

        for j := succ(sp) to pred(SloupcuN) do
        begin
          BodCil.X := BodCil.X + dyC;
          BodCil.Y := BodCil.Y + dxC;
          k := pred(round(      BodCil.X));
          l :=      round(Radku-BodCil.Y) ;
          if (k < 0) or (k >= Sloupcu) or (l < 0) or (l >= Radku) then
            goto 2
          else
          begin
            if sl <> l then
            begin
              fSt^.Read(ObrazS,  l);
              sl := l;
            end;
            PBuffer0(ObrazN)^[j] := PBuffer0(ObrazS)^[k];
          end;
        end;


{$IFDEF Windows}
      2:DalsiKrokAbortNMCallBackPr(0, 0);
        KeepWindowsAliveCallBackPr(0, 0);
        if BylUserAbortAbortNMCallBackPr(0, 0) then
        begin
          Dispose(fN, Done);
(*          ZrusRastr(JmenoNovehoSouboru, false, false);*)
          EscDone := true;
          exit;
        end;
{$ELSE}
      2:if keyPressed then
          if ReadKey = Esc then
            if Souhlas(Sou_SkutecnePrerusitTransf) then
            begin
              Dispose(fN, Done);
              ZrusRastr(JmenoNovehoSouboru);
              EscDone := true;
              exit;
            end;

        if Procenta^.ProvedZmenu then
          Procenta^.Vypis;
{$ENDIF}
      end;
    end;
  end;
  Dispose(fN,Done);
end;


procedure Afin256FalseM(
{$IFDEF Windows}
                              DalsiKrokAbortNMCallBackPr,
                              BylUserAbortAbortNMCallBackPr,
                              KeepWindowsAliveCallBackPr    : TFunctionDLL;
{$ENDIF}
                              TransfPtr                : PTransformace;
                              Sloupcu, Radku           : longInt;
{$IFDEF Windows}
                        const JmenoNovehoSouboru       : TPathStr;
{$ELSE}
                        const JmenoNovehoSouboru       : PathStr;
{$ENDIF}
                              fSt                      : PPRStreamRas;
                              fN                       : PPWStream;
                              MinSSloupcuN, MaxSRadkuN,
                              cSloupcuN, cRadkuN       : extended;
                              SloupcuN, RadkuN         : longInt;
                        var   EscDone                  : boolean
{$IFNDEF Windows}
                                                             ;
                              Procenta                 : TProcentaPtr
{$ENDIF}
                                                                  );

label
  1, 2;

const
  eps = 1E-5;

var
  ObrazN, ObrazS: pointer;
  lSt, sp, i, j, p, q, r, k, l, sl, k_r: longint;
  BodCil, PomBodCil, BodZdr, PomBodZdr: TranType.Bod;
  dxC, dyC, a1, a2, a3, b1, b2, b3, a1_1,
  bpom1, bpom2, bpom3, apom1, apom2, apom3: extended;
  Zapisovat: boolean;
{$IFDEF Windows}
  Retezec1: array[0..255] of char;
{$ENDIF}

begin
  sl := -2147483640;

  with TransfPtr^ do
  begin
{$IFDEF Windows}
    LoadString(HInstance, 621, Retezec1, 256);
    if (StrIComp(TransfPtr^.NazevTransformace, Retezec1{'PODOBN 2D'}) = 0) then
{$ELSE}
    if NazevTransformace = Vyb_Podobn2D{'PODOBN 2D'} then
{$ENDIF}
    begin
      a1   :=  InvKlic[1];
      a2   := -InvKlic[2];
      a3   :=  0;
      b1   :=  InvKlic[2];
      b2   :=  InvKlic[1];
      b3   :=  0;
      a1_1 :=  a1*cSloupcuN-1;
    end else
    begin
      a1   := InvKlic[1];
      a2   := InvKlic[2];
      a3   := InvKlic[3];
      b1   := InvKlic[4];
      b2   := InvKlic[5];
      b3   := InvKlic[6];
      a1_1 := a1*cSloupcuN-1;
    end;

    if abs(b1)   < eps then b1   := 0;
    if abs(a1_1) < eps then a1_1 := 0;

    if ZkouskaAfin256FalseM(TransfPtr, Sloupcu, Radku, MinSSloupcuN, MaxSRadkuN, cSloupcuN, cRadkuN,
                            SloupcuN, RadkuN,
                            a1, a2, a3, b1, b2, b3, a1_1) then
    begin
      BodZdr.Y := MaxSRadkuN + cRadkuN;

      if b1 <> 0 then
        bpom1 := ((-ZdrojStred.Y + 0.5 - b3)/b1 + cSloupcuN + CilStred.X - MinSSloupcuN)/cSloupcuN;
      if a1_1 <> 0 then
      begin
        apom1 := ( -ZdrojStred.X + 0.5 - a3)/a1_1;
        apom2 := ( -ZdrojStred.X - 0.5 - a3)/a1_1;
      end;

      for i := 1 to RadkuN do
      begin
        fN^.NastavRadPtr(ObrazN);
        if fN^.Status <> 0 then
        begin
          Dispose(fN, Done);
          exit;
        end;

        if fN^.Bits4 then
          FillChar(ObrazN^, SloupcuN, 0)
        else
          FillChar(ObrazN^, SloupcuN, 255);

        BodZdr.Y := BodZdr.Y - cRadkuN;
        BodZdr.X := MinSSloupcuN + pred(SloupcuN)*cSloupcuN;
        InvTransformuj(BodZdr, BodCil);

        BodZdr.X := BodZdr.X - cSloupcuN;
        InvTransformuj(BodZdr, PomBodCil);
        BodZdr.X := BodZdr.X + cSloupcuN;

        dxC := PomBodCil.Y - BodCil.Y;
        dyC := PomBodCil.X - BodCil.X;

        PomBodZdr.Y := BodZdr.Y - CilStred.Y;
        bpom3       := PomBodZdr.Y*b2;
        if a1_1 <> 0 then
          apom3       := PomBodZdr.Y*a2/a1_1;

        j := 1;
        repeat
          k := pred(round(      BodCil.X));
          l :=      round(Radku-BodCil.Y);
          if sl <> l then
          begin
            if (l >= 0) and (l < Radku) then
            begin
              Zapisovat := true;
              fSt^.Read(ObrazS,  l);
            end
            else
              Zapisovat := false;
            sl := l;
          end;

          PomBodZdr.X := BodZdr.X - CilStred.X;
          lSt         := round(BodCil.Y);

          if b1 > 0 then
            p := trunc((lSt - bpom3)/(b1*cSloupcuN) + bpom1)
          else
            p := SloupcuN;

          if a1_1 > 0 then
            q := trunc((succ(k) - a1*PomBodZdr.X)/a1_1 + apom1 - apom3)
          else
            if a1_1 < 0 then
              q := trunc((succ(k) - a1*PomBodZdr.X)/a1_1 + apom2 - apom3)
            else
              q := SloupcuN - j;

          if p-j < q then
            r := succ(p-j)
          else
            r := succ(q);

          if r < 1 then
            r := 1;

          if r > succ(SloupcuN - j) then
            r := succ(SloupcuN - j);

          k_r := k-r;

          if (k >= 0) and (k < Sloupcu) and (k_r >= -1) then
          begin
            if Zapisovat then
              move(PBuffer0(ObrazS)^[succ(k_r)], PBuffer0(ObrazN)^[succ(SloupcuN-j-r)], r);
          end
          else
            if k >= Sloupcu then
            begin
              if succ(k_r) < Sloupcu then
              begin
                if pred(Sloupcu) - k_r < Sloupcu then
                begin
                  if Zapisovat and (r > 0)  then
                    move(PBuffer0(ObrazS)^[succ(k_r)], PBuffer0(ObrazN)^[SloupcuN-j-r], pred(Sloupcu) - k_r);
                end else
                begin
                  if Zapisovat then
                    move(PBuffer0(ObrazS)^[0], PBuffer0(ObrazN)^[SloupcuN-j-Sloupcu], Sloupcu);
                  goto 1;
                end;
              end;
            end else
            begin
              if k >= 0 then
                if Zapisovat then
                  move(PBuffer0(ObrazS)^[0], PBuffer0(ObrazN)^[succ(SloupcuN-j-succ(k))], succ(k));
              goto 1;
            end;

          inc(j, r);
          BodCil.X := BodCil.X + r*dyC;
          BodCil.Y := BodCil.Y + r*dxC;
          BodZdr.X := BodZdr.X + r*cSloupcuN;
        until j >= SloupcuN;

{$IFDEF Windows}
      1:DalsiKrokAbortNMCallBackPr(0, 0);
        KeepWindowsAliveCallBackPr(0, 0);
        if BylUserAbortAbortNMCallBackPr(0, 0) then
        begin
          Dispose(fN, Done);
(*          ZrusRastr(JmenoNovehoSouboru, false, false);*)
          EscDone := true;
          exit;
        end;
{$ELSE}
      1:if keyPressed then
          if ReadKey = Esc then
            if Souhlas(Sou_SkutecnePrerusitTransf) then
            begin
              Dispose(fN, Done);
              ZrusRastr(JmenoNovehoSouboru);
              EscDone := true;
              exit;
            end;
        if Procenta^.ProvedZmenu then
          Procenta^.Vypis;
{$ENDIF}
      end;
    end else
    begin
      BodZdr.Y := MaxSRadkuN + CRadkuN;
      for i := 1 to RadkuN do
      begin
        fN^.NastavRadPtr(ObrazN);
        if fN^.Status <> 0 then
        begin
          Dispose(fN, Done);
          exit;
        end;

        if fN^.Bits4 then
          FillChar(ObrazN^, SloupcuN, 0)
        else
          FillChar(ObrazN^, SloupcuN, 255);

        BodZdr.Y := BodZdr.Y - CRadkuN;
        BodZdr.X := MinSSloupcuN + pred(SloupcuN)*cSloupcuN;
        TransfPtr^.InvTransformuj(BodZdr, PomBodCil);

        BodZdr.X := BodZdr.X - CSloupcuN;
        TransfPtr^.InvTransformuj(BodZdr, BodCil);

        dxC := BodCil.Y - PomBodCil.Y;
        dyC := BodCil.X - PomBodCil.X;

        BodCil.X := PomBodCil.X - dyC;
        BodCil.Y := PomBodCil.Y - dxC;

        j := SloupcuN;
        repeat
          dec(j);
          if j = -1 then goto 2;
          BodCil.X := BodCil.X + dyC;
          BodCil.Y := BodCil.Y + dxC;
          k := pred(round(      BodCil.X));
          l :=      round(Radku-BodCil.Y) ;
        until (k >= 0) and (k < Sloupcu) and (l >= 0) and (l < Radku);

        sp := j;
        fSt^.Read(ObrazS, l);
        sl := l;
        PBuffer0(ObrazN)^[j] := PBuffer0(ObrazS)^[k];

        for j := pred(sp) downto 0 do
        begin
          BodCil.X := BodCil.X + dyC;
          BodCil.Y := BodCil.Y + dxC;
          k := pred(round(      BodCil.X));
          l :=      round(Radku-BodCil.Y) ;
          if (k < 0) or (k >= Sloupcu) or (l < 0) or (l >= Radku) then
            goto 2
          else
          begin
            if sl <> l then
            begin
              fSt^.Read(ObrazS, l);
              sl := l;
            end;
            PBuffer0(ObrazN)^[j] := PBuffer0(ObrazS)^[k];
          end;
        end;

{$IFDEF Windows}
      2:DalsiKrokAbortNMCallBackPr(0, 0);
        KeepWindowsAliveCallBackPr(0, 0);
        if BylUserAbortAbortNMCallBackPr(0, 0) then
        begin
          Dispose(fN, Done);
(*          ZrusRastr(JmenoNovehoSouboru, false, false);*)
          EscDone := true;
          exit;
        end;
{$ELSE}
      2:if keyPressed then
          if ReadKey = Esc then
            if Souhlas(Sou_SkutecnePrerusitTransf) then
            begin
              Dispose(fN, Done);
              ZrusRastr(JmenoNovehoSouboru);
              EscDone := true;
              exit;
            end;
        if Procenta^.ProvedZmenu then
          Procenta^.Vypis;
{$ENDIF}
      end;
    end;
  end;
  Dispose(fN,Done);
end;



procedure Ost256TrueM(
{$IFDEF Windows}
                            DalsiKrokAbortNMCallBackPr,
                            BylUserAbortAbortNMCallBackPr,
                            KeepWindowsAliveCallBackPr    : TFunctionDLL;
{$ENDIF}
                            TransfPtr                : PTransformace;
                            Sloupcu, Radku           : longInt;
{$IFDEF Windows}
                      const JmenoNovehoSouboru       : TPathStr;
{$ELSE}
                      const JmenoNovehoSouboru       : PathStr;
{$ENDIF}
                            fSt                      : PPRStreamRas;
                            fN                       : PPWStream;
                            MinSSloupcuN, MaxSRadkuN,
                            cSloupcuN, cRadkuN       : extended;
                            SloupcuN, RadkuN         : longInt;
                      var   EscDone                  : boolean
{$IFNDEF Windows}
                                                             ;
                            Procenta                 : TProcentaPtr
{$ENDIF}
                                                                  );
label
  1;

const
  eps = 1E-5;

var
  ObrazN, ObrazS: pointer;
  sp, i, j, k, l, sl: longint;
  BodCil, BodZdr: TranType.Bod;

begin
  sl := -2147483640;

  with TransfPtr^ do
  begin
    BodZdr.Y := MaxSRadkuN + CRadkuN;
    for i := 1 to RadkuN do
    begin
      fN^.NastavRadPtr(ObrazN);
      if fN^.Status <> 0 then
      begin
        Dispose(fN, Done);
        exit;
      end;

      if fN^.Bits4 then
        FillChar(ObrazN^, SloupcuN, 0)
      else
        FillChar(ObrazN^, SloupcuN, 255);

      BodZdr.Y := BodZdr.Y - CRadkuN;
      BodZdr.X := MinSSloupcuN - CSloupcuN;

      j := -1;
      repeat
        inc(j);;
        if j = SloupcuN then goto 1;
        BodZdr.X := BodZdr.X + CSloupcuN;
        TransfPtr^.InvTransformuj(BodZdr, BodCil);
        k  := pred(round(      BodCil.X));
        sl :=      round(Radku-BodCil.Y) ;
      until (k >= 0) and (k < Sloupcu) and (sl >= 0) and (sl < Radku);

      sp := j;
      fSt^.Read(ObrazS, sl);
      PBuffer0(ObrazN)^[j] := PBuffer0(ObrazS)^[k];

      for j := succ(sp) to pred(SloupcuN) do
      begin
        BodZdr.X := BodZdr.X + CSloupcuN;
        TransfPtr^.InvTransformuj(BodZdr, BodCil);
        k := pred(round(      BodCil.X));
        l :=      round(Radku-BodCil.Y) ;
        if (k < 0) or (k >= Sloupcu) or (l < 0) or (l >= Radku) then
          goto 1
        else
        begin
          if l <> sl then
          begin
            sl := l;
            fSt^.Read(ObrazS, sl);
          end;
          PBuffer0(ObrazN)^[j] := PBuffer0(ObrazS)^[k];
        end;
      end;

{$IFDEF Windows}
    1:DalsiKrokAbortNMCallBackPr(0, 0);
        KeepWindowsAliveCallBackPr(0, 0);
        if BylUserAbortAbortNMCallBackPr(0, 0) then
      begin
        Dispose(fN, Done);
(*        ZrusRastr(JmenoNovehoSouboru, false, false);*)
        EscDone := true;
        exit;
      end;
{$ELSE}
    1:if keyPressed then
        if ReadKey = Esc then
          if Souhlas(Sou_SkutecnePrerusitTransf) then
          begin
            Dispose(fN, Done);
            ZrusRastr(JmenoNovehoSouboru);
            EscDone := true;
            exit;
          end;
      if Procenta^.ProvedZmenu then
        Procenta^.Vypis;
{$ENDIF}
    end;
  end;
  Dispose(fN,Done);
end;




procedure Ost256FalseM(
{$IFDEF Windows}
                             DalsiKrokAbortNMCallBackPr,
                             BylUserAbortAbortNMCallBackPr,
                             KeepWindowsAliveCallBackPr    : TFunctionDLL;
{$ENDIF}
                             TransfPtr                : PTransformace;
                             Sloupcu, Radku           : longInt;
{$IFDEF Windows}
                      const JmenoNovehoSouboru        : TPathStr;
{$ELSE}
                      const JmenoNovehoSouboru        : PathStr;
{$ENDIF}
                             fSt                      : PPRStreamRas;
                             fN                       : PPWStream;
                             MinSSloupcuN, MaxSRadkuN,
                             cSloupcuN, cRadkuN       : extended;
                             SloupcuN, RadkuN         : longInt;
                       var   EscDone                  : boolean
{$IFNDEF Windows}
                                                               ;
                           Procenta                 : TProcentaPtr
{$ENDIF}
                           );
label
  1;

const
  eps = 1E-5;

var
  ObrazN, ObrazS: pointer;
  sp, i, j, k, l, sl: longint;
  BodCil, BodZdr: TranType.Bod;

begin
  sl := -2147483640;

  with TransfPtr^ do
  begin
    BodZdr.Y := MaxSRadkuN + CRadkuN;
    for i := 1 to RadkuN do
    begin
      fN^.NastavRadPtr(ObrazN);
      if fN^.Status <> 0 then
      begin
        Dispose(fN, Done);
        exit;
      end;

      if fN^.Bits4 then
        FillChar(ObrazN^, SloupcuN, 0)
      else
        FillChar(ObrazN^, SloupcuN, 255);

      BodZdr.Y := BodZdr.Y - CRadkuN;
      BodZdr.X := MinSSloupcuN + SloupcuN*CSloupcuN;

      j := SloupcuN;
      repeat
        dec(j);
        if j = -1 then goto 1;
        BodZdr.X := BodZdr.X - CSloupcuN;
        TransfPtr^.InvTransformuj(BodZdr, BodCil);
        k  := pred(round(      BodCil.X));
        sl :=      round(Radku-BodCil.Y) ;
      until (k >= 0) and (k < Sloupcu) and (sl >= 0) and (sl < Radku);

      sp := j;
      fSt^.Read(ObrazS, sl);
      PBuffer0(ObrazN)^[j] := PBuffer0(ObrazS)^[k];

      for j := pred(sp) downto 0 do
      begin
        BodZdr.X := BodZdr.X - CSloupcuN;
        TransfPtr^.InvTransformuj(BodZdr, BodCil);
        k := pred(round(      BodCil.X));
        l :=      round(Radku-BodCil.Y) ;
        if (k < 0) or (k >= Sloupcu) or (l < 0) or (l >= Radku) then
          goto 1
        else
        begin
          if l <> sl then
          begin
            sl := l;
            fSt^.Read(ObrazS, sl);
          end;
          PBuffer0(ObrazN)^[j] := PBuffer0(ObrazS)^[k];
        end;
      end;

{$IFDEF Windows}
    1:DalsiKrokAbortNMCallBackPr(0, 0);
      KeepWindowsAliveCallBackPr(0, 0);
      if BylUserAbortAbortNMCallBackPr(0, 0) then
      begin
        Dispose(fN, Done);
(*        ZrusRastr(JmenoNovehoSouboru, false, false);*)
        EscDone := true;
        exit;
      end;
{$ELSE}
    1:if keyPressed then
        if ReadKey = Esc then
          if Souhlas(Sou_SkutecnePrerusitTransf) then
          begin
            Dispose(fN, Done);
            ZrusRastr(JmenoNovehoSouboru);
            EscDone := true;
            exit;
          end;
      if Procenta^.ProvedZmenu then
        Procenta^.Vypis;
{$ENDIF}
    end;
  end;
  Dispose(fN,Done);
end;



procedure Afin2TrueM(
{$IFDEF Windows}
                           DalsiKrokAbortNMCallBackPr,
                           BylUserAbortAbortNMCallBackPr,
                           KeepWindowsAliveCallBackPr    : TFunctionDLL;
{$ENDIF}
                           TransfPtr                : PTransformace;
                           Sloupcu, Radku           : longInt;
{$IFDEF Windows}
                     const JmenoNovehoSouboru       : TPathStr;
{$ELSE}
                     const JmenoNovehoSouboru       : PathStr;
{$ENDIF}
                           fSt                      : PPRStreamRas;
                           fN                       : PPWStream;
                           MinSSloupcuN, MaxSRadkuN,
                           cSloupcuN, cRadkuN       : extended;
                           SloupcuN, RadkuN         : longInt;
                     var   EscDone                  : boolean
{$IFNDEF Windows}
                                                             ;
                           Procenta                 : TProcentaPtr
{$ENDIF}
                                                                  );
label
  1, 2;

const
  eps = 1E-5;

var
  ObrazN, ObrazS: pointer;
  PocetBytu, lSt, sp, i, j, p, q, r, k, l, sl, k_r: longint;
  BodCil, PomBodCil, BodZdr, PomBodZdr: TranType.Bod;
  dxC, dyC, a1, a2, a3, b1, b2, b3, a1_1,
  bpom1, bpom2, bpom3, apom1, apom2, apom3: extended;
  Zapisovat: boolean;
{$IFDEF Windows}
  Retezec1: array[0..255] of char;
{$ENDIF}

begin
  PocetBytu := SloupcuN shr 3;

  sl := -2147483640;

  with TransfPtr^ do
  begin
{$IFDEF Windows}
    LoadString(HInstance, 621, Retezec1, 256);
    if (StrIComp(TransfPtr^.NazevTransformace, Retezec1{'PODOBN 2D'}) = 0) then
{$ELSE}
    if NazevTransformace = Vyb_Podobn2D{'PODOBN 2D'} then
{$ENDIF}
    begin
      a1   :=  InvKlic[1];
      a2   := -InvKlic[2];
      a3   :=  0;
      b1   :=  InvKlic[2];
      b2   :=  InvKlic[1];
      b3   :=  0;
      a1_1 :=  1-a1*cSloupcuN;
    end else
    begin
      a1   := InvKlic[1];
      a2   := InvKlic[2];
      a3   := InvKlic[3];
      b1   := InvKlic[4];
      b2   := InvKlic[5];
      b3   := InvKlic[6];
      a1_1 := 1-a1*cSloupcuN;
    end;

    if abs(b1)   < eps then b1   := 0;
    if abs(a1_1) < eps then a1_1 := 0;

    if ZkouskaAfin2TrueM(TransfPtr, Sloupcu, Radku, MinSSloupcuN, MaxSRadkuN, cSloupcuN, cRadkuN,
                         SloupcuN, RadkuN,
                         a1, a2, a3, b1, b2, b3, a1_1) then
    begin
      BodZdr.Y := MaxSRadkuN + cRadkuN;

      if b1 <> 0 then
        bpom1 := ((-ZdrojStred.Y + 0.5 - b3)/b1 + cSloupcuN + CilStred.X - MinSSloupcuN)/cSloupcuN;
      if a1_1 <> 0 then
      begin
        apom1 := ( -ZdrojStred.X + 0.5 - a3)/a1_1;
        apom2 := ( -ZdrojStred.X - 0.5 - a3)/a1_1;
      end;

      for i := 1 to RadkuN do
      begin
        fN^.NastavRadPtr(ObrazN);
        if fN^.Status <> 0 then
        begin
          Dispose(fN, Done);
          exit;
        end;

        fillchar(ObrazN^, PocetBytu, 255);

        BodZdr.Y := BodZdr.Y - cRadkuN;
        BodZdr.X := MinSSloupcuN - cSloupcuN;
        InvTransformuj(BodZdr, PomBodCil);

        BodZdr.X := BodZdr.X + cSloupcuN;
        InvTransformuj(BodZdr, BodCil);

        dxC := PomBodCil.Y - BodCil.Y;
        dyC := PomBodCil.X - BodCil.X;

        PomBodZdr.Y := (BodZdr.Y - CilStred.Y);
        bpom3       := PomBodZdr.Y*b2;
        if a1_1 <> 0 then
          apom3     := PomBodZdr.Y*a2/a1_1;

        j := 0;
        repeat
          k := pred(round(      BodCil.X));
          l :=      round(Radku-BodCil.Y);
          if sl <> l then
          begin
            if (l >= 0) and (l < Radku) then
            begin
              Zapisovat := true;
              fSt^.Read(ObrazS, l);
            end
            else
              Zapisovat := false;
            sl := l;
          end;

          PomBodZdr.X := BodZdr.X - CilStred.X;
          lSt         := round(BodCil.Y);

          if b1 < 0 then
            p := trunc(SloupcuN - ((lSt - bpom3)/(b1*cSloupcuN) + bpom1))
          else
            p := pred(SloupcuN);

          if a1_1 > 0 then
            q := trunc((succ(k) - a1*PomBodZdr.X)/a1_1 + apom1 - apom3)
          else
            if a1_1 < 0 then
              q := trunc((succ(k) - a1*PomBodZdr.X)/a1_1 + apom2 - apom3)
            else
              q := pred(SloupcuN - j);

          if p-j < q then
            r := succ(p-j)
          else
            r := succ(q);

          if r < 1 then
            r := 1;

          if r > SloupcuN - j then
            r := SloupcuN - j;

          k_r := k+r;

          if (k >= 0) and (k < Sloupcu) and (k_r < Sloupcu) then
          begin
            if Zapisovat then
              WindowLine(ObrazS^, ObrazN^, k, j, r);
          end
          else
            if k < 0 then
            begin
              if k_r >= 0 then
              begin
                inc(j, -k);
                inc(r,  k);
                if r >= Sloupcu then
                begin
                  if Zapisovat then
                    WindowLine(ObrazS^, ObrazN^, 0, j, Sloupcu);
                  goto 1;
                end else
                begin
                  BodCil.X := BodCil.X - k*dyC;
                  BodCil.Y := BodCil.Y - k*dxC;
                  BodZdr.X := BodZdr.X + k*cSloupcuN;
                  if Zapisovat and (r > 0)  then
                    WindowLine(ObrazS^, ObrazN^, 0, j, r);
                end;
              end;
            end else
            begin
              if k < Sloupcu then
                if Zapisovat then
                  WindowLine(ObrazS^, ObrazN^, k, j, succ(Sloupcu-k));
              goto 1;
            end;

          inc(j, r);
          BodCil.X := BodCil.X + r*dyC;
          BodCil.Y := BodCil.Y + r*dxC;
          BodZdr.X := BodZdr.X - r*cSloupcuN;
        until j >= pred(SloupcuN);

{$IFDEF Windows}
      1:DalsiKrokAbortNMCallBackPr(0, 0);
        KeepWindowsAliveCallBackPr(0, 0);
        if BylUserAbortAbortNMCallBackPr(0, 0) then
        begin
          Dispose(fN, Done);
(*          ZrusRastr(JmenoNovehoSouboru, false, false);*)
          EscDone := true;
          exit;
        end;
{$ELSE}
      1:if keyPressed then
          if ReadKey = Esc then
            if Souhlas(Sou_SkutecnePrerusitTransf) then
            begin
              Dispose(fN, Done);
              ZrusRastr(JmenoNovehoSouboru);
              EscDone := true;
              exit;
            end;
        if Procenta^.ProvedZmenu then
          Procenta^.Vypis;
{$ENDIF}
      end;
    end else
    begin
      BodZdr.Y := MaxSRadkuN + CRadkuN;

      for i := 1 to RadkuN do
      begin
        fN^.NastavRadPtr(ObrazN);
        if fN^.Status <> 0 then
        begin
          Dispose(fN, Done);
          exit;
        end;

        fillchar(ObrazN^, PocetBytu, 255);
        with TransfPtr^ do
        begin
          BodZdr.X := MinSSloupcuN;
          BodZdr.Y := BodZdr.Y - CRadkuN;
          InvTransformuj(BodZdr, PomBodCil);

          BodZdr.X := BodZdr.X + CSloupcuN;
          InvTransformuj(BodZdr, BodCil);

          dxC := BodCil.Y - PomBodCil.Y;
          dyC := BodCil.X - PomBodCil.X;

          BodCil.X := PomBodCil.X - dyC;
          BodCil.Y := PomBodCil.Y - dxC;
        end;

        j := -1;
        repeat
          inc(j);
          if j = SloupcuN then goto 2;
          BodCil.X := BodCil.X + dyC;
          BodCil.Y := BodCil.Y + dxC;
          k := pred(round(      BodCil.X));
          l :=      round(Radku-BodCil.Y) ;
        until (k >= 0) and (k < Sloupcu) and (l >= 0) and (l < Radku);
        sp := j;

        if sl <> l then
        begin
          fSt^.Read(ObrazS, l);
          sl := l;
        end;
        urci(ObrazS^, ObrazN^, k, j);

        for j := succ(sp) to pred(SloupcuN) do
        begin
          BodCil.X := BodCil.X + dyC;
          BodCil.Y := BodCil.Y + dxC;
          k := pred(round(      BodCil.X));
          l :=      round(Radku-BodCil.Y) ;
          if (k < 0) or (k >= Sloupcu) or (l < 0) or (l >= Radku) then
            goto 2
          else
          begin
            if sl <> l then
            begin
              fSt^.Read(ObrazS, l);
              sl := l;
            end;
            urci(ObrazS^, ObrazN^, k, j)
          end;
        end;

{$IFDEF Windows}
      2:DalsiKrokAbortNMCallBackPr(0, 0);
        KeepWindowsAliveCallBackPr(0, 0);
        if BylUserAbortAbortNMCallBackPr(0, 0) then
        begin
          Dispose(fN, Done);
(*          ZrusRastr(JmenoNovehoSouboru, false, false);*)
          EscDone := true;
          exit;
        end;
{$ELSE}
      2:if keyPressed then
          if ReadKey = Esc then
            if Souhlas(Sou_SkutecnePrerusitTransf) then
            begin
              Dispose(fN, Done);
              ZrusRastr(JmenoNovehoSouboru);
              EscDone := true;
              exit;
            end;
        if Procenta^.ProvedZmenu then
          Procenta^.Vypis;
{$ENDIF}
      end;
    end;
  end;
  Dispose(fN,Done);
end;


procedure Afin2FalseM(
{$IFDEF Windows}
                           DalsiKrokAbortNMCallBackPr,
                           BylUserAbortAbortNMCallBackPr,
                           KeepWindowsAliveCallBackPr    : TFunctionDLL;
{$ENDIF}
                           TransfPtr                : PTransformace;
                           Sloupcu, Radku           : longInt;
{$IFDEF Windows}
                     const JmenoNovehoSouboru       : TPathStr;
{$ELSE}
                     const JmenoNovehoSouboru       : PathStr;
{$ENDIF}
                           fSt                      : PPRStreamRas;
                           fN                       : PPWStream;
                           MinSSloupcuN, MaxSRadkuN,
                           cSloupcuN, cRadkuN       : extended;
                           SloupcuN, RadkuN         : longInt;
                      var  EscDone                  : boolean
{$IFNDEF Windows}
                                                             ;
                           Procenta                 : TProcentaPtr
{$ENDIF}
                                                                  );

label
  1, 2;

const
  eps = 1E-5;

var
  ObrazN, ObrazS: pointer;
  PocetBytu, lSt, sp, i, j, p, q, r, k, l, sl, k_r: longint;
  BodCil, PomBodCil, BodZdr, PomBodZdr: TranType.Bod;
  dxC, dyC, a1, a2, a3, b1, b2, b3, a1_1,
  bpom1, bpom2, bpom3, apom1, apom2, apom3: extended;
  Zapisovat: boolean;
{$IFDEF Windows}
  Retezec1: array[0..255] of char;
{$ENDIF}

begin
  PocetBytu := SloupcuN shr 3;

  sl := -2147483640;

  with TransfPtr^ do
  begin
{$IFDEF Windows}
    LoadString(HInstance, 621, Retezec1, 256);
    if (StrIComp(TransfPtr^.NazevTransformace, Retezec1{'PODOBN 2D'}) = 0) then
{$ELSE}
    if NazevTransformace = Vyb_Podobn2D{'PODOBN 2D'} then
{$ENDIF}
    begin
      a1   :=  InvKlic[1];
      a2   := -InvKlic[2];
      a3   :=  0;
      b1   :=  InvKlic[2];
      b2   :=  InvKlic[1];
      b3   :=  0;
      a1_1 :=  a1*cSloupcuN-1;
    end else
    begin
      a1   := InvKlic[1];
      a2   := InvKlic[2];
      a3   := InvKlic[3];
      b1   := InvKlic[4];
      b2   := InvKlic[5];
      b3   := InvKlic[6];
      a1_1 := a1*cSloupcuN-1;
    end;

    if abs(b1)   < eps then b1   := 0;
    if abs(a1_1) < eps then a1_1 := 0;

    if ZkouskaAfin2FalseM(TransfPtr, Sloupcu, Radku, MinSSloupcuN, MaxSRadkuN, cSloupcuN, cRadkuN,
                          SloupcuN, RadkuN,
                          a1, a2, a3, b1, b2, b3, a1_1) then
    begin
      BodZdr.Y := MaxSRadkuN + cRadkuN;

      if b1 <> 0 then
        bpom1 := ((-ZdrojStred.Y + 0.5 - b3)/b1 + cSloupcuN + CilStred.X - MinSSloupcuN)/cSloupcuN;
      if a1_1 <> 0 then
      begin
        apom1 := ( -ZdrojStred.X + 0.5 - a3)/a1_1;
        apom2 := ( -ZdrojStred.X - 0.5 - a3)/a1_1;
      end;

      for i := 1 to RadkuN do
      begin
        fN^.NastavRadPtr(ObrazN);
        if fN^.Status <> 0 then
        begin
          Dispose(fN, Done);
          exit;
        end;

        fillChar(ObrazN^, PocetBytu, 255);

        BodZdr.Y := BodZdr.Y - cRadkuN;
        BodZdr.X := MinSSloupcuN + SloupcuN*cSloupcuN;
        InvTransformuj(BodZdr, PomBodCil);

        BodZdr.X := BodZdr.X - cSloupcuN;
        InvTransformuj(BodZdr, BodCil);

        dxC := PomBodCil.Y - BodCil.Y;
        dyC := PomBodCil.X - BodCil.X;

        PomBodZdr.Y := BodZdr.Y - CilStred.Y;
        bpom3       := PomBodZdr.Y*b2;
        if a1_1 <> 0 then
          apom3       := PomBodZdr.Y*a2/a1_1;

        j := 1;
        repeat
          k := pred(round(      BodCil.X));
          l :=      round(Radku-BodCil.Y);
          if sl <> l then
          begin
            if (l >= 0) and (l < Radku) then
            begin
              Zapisovat := true;
              fSt^.Read(ObrazS, l);
            end
            else
              Zapisovat := false;
            sl := l;
          end;
          PomBodZdr.X := BodZdr.X - CilStred.X;
          lSt         := round(BodCil.Y);

          if b1 > 0 then
            p := trunc((lSt - bpom3)/(b1*cSloupcuN) + bpom1)
          else
            p := SloupcuN;

          if a1_1 > 0 then
            q := trunc((succ(k) - a1*PomBodZdr.X)/a1_1 + apom1 - apom3)
          else
            if a1_1 < 0 then
              q := trunc((succ(k) - a1*PomBodZdr.X)/a1_1 + apom2 - apom3)
            else
              q := SloupcuN - j;

          if p-j < q then
            r := succ(p-j)
          else
            r := succ(q);

          if r < 1 then
            r := 1;

          if r > succ(SloupcuN - j) then
            r := succ(SloupcuN - j);

          k_r := k-r;

          if (k >= 0) and (k < Sloupcu) and (k_r >= -1) then
          begin
            if Zapisovat then
              WindowLine(ObrazS^, ObrazN^, succ(k_r), succ(SloupcuN-j-r), r);
          end
          else
            if k >= Sloupcu then
            begin
              if succ(k_r) < Sloupcu then
              begin
                if pred(Sloupcu) - k_r < Sloupcu then
                begin
                  if Zapisovat and (r > 0)  then
                    WindowLine(ObrazS^, ObrazN^, succ(k_r), SloupcuN-j-r, pred(Sloupcu) - k_r);
                end else
                begin
                  if Zapisovat then
                    WindowLine(ObrazS^, ObrazN^, 0, SloupcuN-j-Sloupcu, Sloupcu);
                  goto 1;
                end;
              end;
            end else
            begin
              if k >= 0 then
                if Zapisovat then
                  WindowLine(ObrazS^, ObrazN^, 0, succ(SloupcuN-j-succ(k)), succ(k));
              goto 1;
            end;

          inc(j, r);
          BodCil.X := BodCil.X + r*dyC;
          BodCil.Y := BodCil.Y + r*dxC;
          BodZdr.X := BodZdr.X + r*cSloupcuN;
        until j >= SloupcuN;

{$IFDEF Windows}
      1:DalsiKrokAbortNMCallBackPr(0, 0);
        KeepWindowsAliveCallBackPr(0, 0);
        if BylUserAbortAbortNMCallBackPr(0, 0) then
        begin
          Dispose(fN, Done);
(*          ZrusRastr(JmenoNovehoSouboru, false, false);*)
          EscDone := true;
          exit;
        end;
{$ELSE}
      1:if keyPressed then
          if ReadKey = Esc then
            if Souhlas(Sou_SkutecnePrerusitTransf) then
            begin
              Dispose(fN, Done);
              ZrusRastr(JmenoNovehoSouboru);
              EscDone := true;
              exit;
            end;
        if Procenta^.ProvedZmenu then
          Procenta^.Vypis;
{$ENDIF}
      end;
    end else
    begin
      BodZdr.Y := MaxSRadkuN + CRadkuN;
      for i := 1 to RadkuN do
      begin
        fN^.NastavRadPtr(ObrazN);
        if fN^.Status <> 0 then
        begin
          Dispose(fN, Done);
          exit;
        end;

        fillchar(ObrazN^, PocetBytu, 255);
        with TransfPtr^ do
        begin
          BodZdr.Y := BodZdr.Y - CRadkuN;
          BodZdr.X := MinSSloupcuN + pred(SloupcuN)*cSloupcuN;
          InvTransformuj(BodZdr, PomBodCil);

          BodZdr.X := BodZdr.X - CSloupcuN;
          InvTransformuj(BodZdr, BodCil);

          dxC := BodCil.Y - PomBodCil.Y;
          dyC := BodCil.X - PomBodCil.X;

          BodCil.X := PomBodCil.X - dyC;
          BodCil.Y := PomBodCil.Y - dxC;
        end;

        j := SloupcuN;
        repeat
          dec(j);
          if j = -1 then goto 2;
          BodCil.X := BodCil.X + dyC;
          BodCil.Y := BodCil.Y + dxC;
          k := pred(round(      BodCil.X));
          l :=      round(Radku-BodCil.Y) ;
        until (k >= 0) and (k < Sloupcu) and (l >= 0) and (l < Radku);
        sp := j;

        if sl <> l then
        begin
          fSt^.Read(ObrazS, l);
          sl := l;
        end;
        urci(ObrazS^, ObrazN^, k, j);

        for j := pred(sp) downto 0 do
        begin
          BodCil.X := BodCil.X + dyC;
          BodCil.Y := BodCil.Y + dxC;
          k := pred(round(      BodCil.X));
          l :=      round(Radku-BodCil.Y) ;
          if (k < 0) or (k >= Sloupcu) or (l < 0) or (l >= Radku) then
            goto 2
          else
          begin
            if sl <> l then
            begin
              fSt^.Read(ObrazS, l);
              sl := l;
            end;
            urci(ObrazS^, ObrazN^, k, j)
          end;
        end;

{$IFDEF Windows}
      2:DalsiKrokAbortNMCallBackPr(0, 0);
        KeepWindowsAliveCallBackPr(0, 0);
        if BylUserAbortAbortNMCallBackPr(0, 0) then
        begin
          Dispose(fN, Done);
(*          ZrusRastr(JmenoNovehoSouboru, false, false);*)
          EscDone := true;
          exit;
        end;
{$ELSE}
      2:if keyPressed then
          if ReadKey = Esc then
            if Souhlas(Sou_SkutecnePrerusitTransf) then
            begin
              Dispose(fN, Done);
              ZrusRastr(JmenoNovehoSouboru);
              EscDone := true;
              exit;
            end;
        if Procenta^.ProvedZmenu then
          Procenta^.Vypis;
{$ENDIF}
      end;
    end;
  end;
  Dispose(fN,Done);
end;


procedure Ost2TrueM(
{$IFDEF Windows}
                        DalsiKrokAbortNMCallBackPr,
                        BylUserAbortAbortNMCallBackPr,
                        KeepWindowsAliveCallBackPr    : TFunctionDLL;
{$ENDIF}
                        TransfPtr                : PTransformace;
                        Sloupcu, Radku           : longInt;
{$IFDEF Windows}
                  const JmenoNovehoSouboru       : TPathStr;
{$ELSE}
                  const JmenoNovehoSouboru       : PathStr;
{$ENDIF}
                        fSt                      : PPRStreamRas;
                        fN                       : PPWStream;
                        MinSSloupcuN, MaxSRadkuN,
                        cSloupcuN, cRadkuN       : extended;
                        SloupcuN, RadkuN         : longInt;
                    var EscDone                  : boolean
{$IFNDEF Windows}
                                                          ;
                        Procenta                 : TProcentaPtr
{$ENDIF}
                                                               );

label
  1;

const
  eps = 1E-5;

var
  ObrazN, ObrazS: pointer;
  PocetBytu, sp, i, j, k, l, sl: longint;
  BodCil, BodZdr: TranType.Bod;

begin
  PocetBytu := SloupcuN shr 3;

  sl := -2147483640;

  with TransfPtr^ do
  begin
    BodZdr.Y := MaxSRadkuN + CRadkuN;
    for i := 1 to RadkuN do
    begin
      fN^.NastavRadPtr(ObrazN);
      if fN^.Status <> 0 then
      begin
        Dispose(fN, Done);
        exit;
      end;

      fillchar(ObrazN^, PocetBytu, 255);
      BodZdr.Y := BodZdr.Y - CRadkuN;
      BodZdr.X := MinSSloupcuN - CSloupcuN;

      j := -1;
      repeat
        inc(j);
        if j = SloupcuN then goto 1;
        BodZdr.X := BodZdr.X + CSloupcuN;
        InvTransformuj(BodZdr, BodCil);
        k := pred(round(      BodCil.X));
        l :=      round(Radku-BodCil.Y) ;
      until (k >= 0) and (k < Sloupcu) and (l >= 0) and (l < Radku);
      sp := j;

      if sl <> l then
      begin
        fSt^.Read(ObrazS, l);
        sl := l;
      end;
      urci(ObrazS^, ObrazN^, k, j);

      for j := succ(sp) to pred(SloupcuN) do
      begin
        BodZdr.X := BodZdr.X + CSloupcuN;
        InvTransformuj(BodZdr, BodCil);
        k := pred(round(      BodCil.X));
        l :=      round(Radku-BodCil.Y) ;
        if (k < 0) or (k >= Sloupcu) or (l < 0) or (l >= Radku) then
          goto 1
        else
        begin
          if sl <> l then
          begin
            fSt^.Read(ObrazS, l);
            sl := l;
          end;
          urci(ObrazS^, ObrazN^, k, j)
        end;
      end;

{$IFDEF Windows}
    1:DalsiKrokAbortNMCallBackPr(0, 0);
      KeepWindowsAliveCallBackPr(0, 0);
      if BylUserAbortAbortNMCallBackPr(0, 0) then
      begin
        Dispose(fN, Done);
(*        ZrusRastr(JmenoNovehoSouboru, false, false);*)
        EscDone := true;
        exit;
      end;
{$ELSE}
    1:if keyPressed then
        if ReadKey = Esc then
          if Souhlas(Sou_SkutecnePrerusitTransf) then
          begin
            Dispose(fN, Done);
            ZrusRastr(JmenoNovehoSouboru);
            EscDone := true;
            exit;
          end;
      if Procenta^.ProvedZmenu then
        Procenta^.Vypis;
{$ENDIF}
    end;
  end;
  Dispose(fN,Done);
end;




procedure Ost2FalseM(
{$IFDEF Windows}
                         DalsiKrokAbortNMCallBackPr,
                         BylUserAbortAbortNMCallBackPr,
                         KeepWindowsAliveCallBackPr    : TFunctionDLL;
{$ENDIF}
                         TransfPtr                : PTransformace;
                         Sloupcu, Radku           : longInt;
{$IFDEF Windows}
                   const JmenoNovehoSouboru       : TPathStr;
{$ELSE}
                   const JmenoNovehoSouboru       : PathStr;
{$ENDIF}
                         fSt                      : PPRStreamRas;
                         fN                       : PPWStream;
                         MinSSloupcuN, MaxSRadkuN,
                         cSloupcuN, cRadkuN       : extended;
                         SloupcuN, RadkuN         : longInt;
                     var EscDone                  : boolean
{$IFNDEF Windows}
                                                          ;
                         Procenta                 : TProcentaPtr
{$ENDIF}
                                                               );

label
  1;

const
  eps = 1E-5;

var
  ObrazN, ObrazS: pointer;
  PocetBytu, sp, i, j, k, l, sl: longint;
  BodCil, BodZdr: TranType.Bod;

begin
  PocetBytu := SloupcuN shr 3;

  sl := -2147483640;

  with TransfPtr^ do
  begin
    BodZdr.Y := MaxSRadkuN + CRadkuN;
    for i := 1 to RadkuN do
    begin
      fN^.NastavRadPtr(ObrazN);
      if fN^.Status <> 0 then
      begin
        Dispose(fN, Done);
        exit;
      end;

      fillchar(ObrazN^, PocetBytu, 255);
      BodZdr.Y := BodZdr.Y - CRadkuN;
      BodZdr.X := MinSSloupcuN + SloupcuN*cSloupcuN;
      j := SloupcuN;
      repeat
        dec(j);
        if j = -1 then goto 1;
        BodZdr.X := BodZdr.X - CSloupcuN;
        TransfPtr^.InvTransformuj(BodZdr, BodCil);
        k := pred(round(      BodCil.X));
        l :=      round(Radku-BodCil.Y) ;
      until (k >= 0) and (k < Sloupcu) and (l >= 0) and (l < Radku);

      sp := j;
      if sl <> l then
      begin
        fSt^.Read(ObrazS, l);
        sl := l;
      end;
      urci(ObrazS^, ObrazN^, k, j);

      for j := pred(sp) downto 0 do
      begin
        BodZdr.X := BodZdr.X - CSloupcuN;
        TransfPtr^.InvTransformuj(BodZdr, BodCil);
        k := pred(round(      BodCil.X));
        l :=      round(Radku-BodCil.Y) ;
        if (k < 0) or (k >= Sloupcu) or (l < 0) or (l >= Radku) then
          goto 1
        else
        begin
          if sl <> l then
          begin
            fSt^.Read(ObrazS, l);
            sl := l;
          end;
          urci(ObrazS^, ObrazN^, k, j)
        end;
      end;

{$IFDEF Windows}
    1:DalsiKrokAbortNMCallBackPr(0, 0);
      KeepWindowsAliveCallBackPr(0, 0);
      if BylUserAbortAbortNMCallBackPr(0, 0) then
      begin
        Dispose(fN, Done);
(*        ZrusRastr(JmenoNovehoSouboru, false, false);*)
        EscDone := true;
        exit;
      end;
{$ELSE}
    1:if keyPressed then
        if ReadKey = Esc then
          if Souhlas(Sou_SkutecnePrerusitTransf) then
          begin
            Dispose(fN, Done);
            ZrusRastr(JmenoNovehoSouboru);
            EscDone := true;
            exit;
          end;
      if Procenta^.ProvedZmenu then
        Procenta^.Vypis;
{$ENDIF}
    end;
  end;
  Dispose(fN,Done);
end;






procedure TransformujRastr256M(
{$IFDEF Windows}
                                   DalsiKrokAbortNMCallBackPr,
                                   BylUserAbortAbortNMCallBackPr,
                                   KeepWindowsAliveCallBackPr    : TFunctionDLL;
{$ENDIF}
                                   TransfPtr                : PTransformace;
                                   Sloupcu, Radku           : longInt;
{$IFDEF Windows}
                             const JmenoNovehoSouboru       : TPathStr;
{$ELSE}
                             const JmenoNovehoSouboru       : PathStr;
{$ENDIF}
                                   fSt                      : PPRStreamRas;
                                   Head                     : TypHeader;
                                   MinSSloupcuN, MaxSRadkuN,
                                   cSloupcuN, cRadkuN       : extended;
                                   SloupcuN, RadkuN         : longInt;
                               var EscDone                  : boolean;
                                   GaussSystem              : boolean
{$IFNDEF Windows}
                                                                     ;
                                   Procenta                 : TProcentaPtr
{$ENDIF}
                                                                          );


var
  fN: PPWStream;
{$IFDEF Windows}
  Retezec1, Retezec2: array[0..255] of char;
{$ENDIF}

begin
  EscDone := false;

  if fSt^.Bits4 then
    fN := New(PPWStream,Init(JmenoNovehoSouboru, 3, SloupcuN shr 1, TopolHeaderSize, 65000))
  else
    fN := New(PPWStream,Init(JmenoNovehoSouboru, 1, SloupcuN, TopolHeaderSize, 65000));
  if fN^.Status <> 0 then
  begin
    Dispose(fN, Done);
    exit;
  end;

  with Head do
    if GaussSystem then
    begin
      xRasMax := MaxSRadkuN;
      yRasMin := MinSSloupcuN;
      xRasMin := MaxSRadkuN   - pred(RadkuN)   * CRadkuN;
      yRasMax := MinSSloupcuN + pred(SloupcuN) * CSloupcuN;
      Rows    := RadkuN;
      Cols    := SloupcuN;
      Zoom    := 0;
    end else
    begin
      yRasMax := MaxSRadkuN;
      xRasMin := MinSSloupcuN;
      yRasMin := MaxSRadkuN   - pred(RadkuN)   * CRadkuN;
      xRasMax := MinSSloupcuN + pred(SloupcuN) * CSloupcuN;
      Rows    := RadkuN;
      Cols    := SloupcuN;
      Zoom    := 0;
    end;

  fN^.PisHeader(Head);
  if fN^.Status <> 0 then
  begin
    Dispose(fN, Done);
    exit;
  end;

  if UrciNatoceni(TransfPtr, MinSSloupcuN, MaxSRadkuN, cSloupcuN, SloupcuN) then
    with TransfPtr^ do
    begin
{$IFDEF Windows}
      LoadString(HInstance, 621, Retezec1, 256);
      LoadString(HInstance, 622, Retezec2, 256);
      if (StrIComp(NazevTransformace, Retezec1{'PODOBN 2D'}) = 0) or
         (StrIComp(NazevTransformace, Retezec2{'AFINN  2D'}) = 0) then
{$ELSE}
      if (NazevTransformace = Vyb_Podobn2D{'PODOBN 2D'}) or (NazevTransformace = Vyb_Afinn2D{'AFINN  2D'}) then
{$ENDIF}
        Afin256TrueM(
{$IFDEF Windows}
                     DalsiKrokAbortNMCallBackPr,
                     BylUserAbortAbortNMCallBackPr,
                     KeepWindowsAliveCallBackPr,
{$ENDIF}
                     TransfPtr, Sloupcu, Radku, JmenoNovehoSouboru, fSt, fN,
                     MinSSloupcuN, MaxSRadkuN, cSloupcuN, cRadkuN, SloupcuN, RadkuN, EscDone
                     {$IFNDEF Windows}, Procenta{$ENDIF})
      else
        Ost256TrueM(
{$IFDEF Windows}
                    DalsiKrokAbortNMCallBackPr,
                    BylUserAbortAbortNMCallBackPr,
                    KeepWindowsAliveCallBackPr,
{$ENDIF}
                    TransfPtr, Sloupcu, Radku, JmenoNovehoSouboru, fSt, fN,
                    MinSSloupcuN, MaxSRadkuN, cSloupcuN, cRadkuN, SloupcuN, RadkuN, EscDone
                    {$IFNDEF Windows}, Procenta{$ENDIF});
    end
  else
    with TransfPtr^ do
    begin
{$IFDEF Windows}
      LoadString(HInstance, 621, Retezec1, 256);
      LoadString(HInstance, 622, Retezec2, 256);
      if (StrIComp(NazevTransformace, Retezec1{'PODOBN 2D'}) = 0) or
         (StrIComp(NazevTransformace, Retezec2{'AFINN  2D'}) = 0) then
{$ELSE}
      if (NazevTransformace = Vyb_Podobn2D{'PODOBN 2D'}) or (NazevTransformace = Vyb_Afinn2D{'AFINN  2D'}) then
{$ENDIF}
        Afin256FalseM(
{$IFDEF Windows}
                      DalsiKrokAbortNMCallBackPr,
                      BylUserAbortAbortNMCallBackPr,
                      KeepWindowsAliveCallBackPr,
{$ENDIF}
                      TransfPtr, Sloupcu, Radku, JmenoNovehoSouboru, fSt, fN,
                      MinSSloupcuN, MaxSRadkuN, cSloupcuN, cRadkuN, SloupcuN, RadkuN, EscDone
                      {$IFNDEF Windows}, Procenta{$ENDIF})
      else
        Ost256FalseM(
{$IFDEF Windows}
                     DalsiKrokAbortNMCallBackPr,
                     BylUserAbortAbortNMCallBackPr,
                     KeepWindowsAliveCallBackPr,
{$ENDIF}
                     TransfPtr, Sloupcu, Radku, JmenoNovehoSouboru, fSt, fN,
                     MinSSloupcuN, MaxSRadkuN, cSloupcuN, cRadkuN, SloupcuN, RadkuN, EscDone
                     {$IFNDEF Windows}, Procenta{$ENDIF});
    end;
end;



procedure TransformujRastr2M(
{$IFDEF Windows}
                                 DalsiKrokAbortNMCallBackPr,
                                 BylUserAbortAbortNMCallBackPr,
                                 KeepWindowsAliveCallBackPr    : TFunctionDLL;
{$ENDIF}
                                 TransfPtr                : PTransformace;
                                 Sloupcu, Radku           : longInt;
{$IFDEF Windows}
                           const JmenoNovehoSouboru       : TPathStr;
{$ELSE}
                           const JmenoNovehoSouboru       : PathStr;
{$ENDIF}
                                 fSt                      : PPRStreamRas;
                                 Head                     : TypHeader;
                                 MinSSloupcuN, MaxSRadkuN,
                                 cSloupcuN, cRadkuN       : extended;
                                 SloupcuN, RadkuN         : longInt;
                             var EscDone                  : boolean;
                                 GaussSystem              : boolean
{$IFNDEF Windows}
                                                                   ;
                                 Procenta                 : TProcentaPtr
{$ENDIF}
                                                                        );

var
  fN: PPWStream;
  m: integer;
{$IFDEF Windows}
  Retezec1, Retezec2: array[0..255] of char;
{$ENDIF}

begin
  EscDone := false;

  if SloupcuN mod 8 <> 0 then
    m := succ(SloupcuN shr 3)
  else
    m := SloupcuN shr 3;

  SloupcuN := m shl 3;

  fN := New(PPWStream,Init(JmenoNovehoSouboru, 0, m, TopolHeaderSize, 65000));
  if fN^.Status <> 0 then
  begin
    Dispose(fN, Done);
    exit;
  end;

  with Head do
    if GaussSystem then
    begin
      xRasMax := MaxSRadkuN;
      yRasMin := MinSSloupcuN;
      xRasMin := MaxSRadkuN   - pred(RadkuN)   * CRadkuN;
      yRasMax := MinSSloupcuN + pred(SloupcuN) * CSloupcuN;
      Rows    := RadkuN;
      Cols    := SloupcuN;
      Zoom    := 0;
    end else
    begin
      yRasMax := MaxSRadkuN;
      xRasMax := MinSSloupcuN + pred(SloupcuN) * CSloupcuN;
      yRasMin := MaxSRadkuN   - pred(RadkuN)   * CRadkuN;
      xRasMin := MinSSloupcuN;
      Rows    := RadkuN;
      Cols    := SloupcuN;
      Zoom    := 0;
    end;

  fN^.PisHeader(Head);
  if fN^.Status <> 0 then
  begin
    Dispose(fN, Done);
    exit;
  end;

  if UrciNatoceni(TransfPtr, MinSSloupcuN, MaxSRadkuN, cSloupcuN, SloupcuN) then
    with TransfPtr^ do
    begin
{$IFDEF Windows}
      LoadString(HInstance, 621, Retezec1, 256);
      LoadString(HInstance, 622, Retezec2, 256);
      if (StrIComp(NazevTransformace, Retezec1{'PODOBN 2D'}) = 0) or
         (StrIComp(NazevTransformace, Retezec2{'AFINN  2D'}) = 0) then
{$ELSE}
      if (NazevTransformace = Vyb_Podobn2D{'PODOBN 2D'}) or (NazevTransformace = Vyb_Afinn2D{'AFINN  2D'}) then
{$ENDIF}
        Afin2TrueM(
{$IFDEF Windows}
                   DalsiKrokAbortNMCallBackPr,
                   BylUserAbortAbortNMCallBackPr,
                   KeepWindowsAliveCallBackPr,
{$ENDIF}
                   TransfPtr, Sloupcu, Radku, JmenoNovehoSouboru, fSt, fN,
                   MinSSloupcuN, MaxSRadkuN, cSloupcuN, cRadkuN, SloupcuN, RadkuN, EscDone
                   {$IFNDEF Windows}, Procenta{$ENDIF})
      else
        Ost2TrueM(
{$IFDEF Windows}
                  DalsiKrokAbortNMCallBackPr,
                  BylUserAbortAbortNMCallBackPr,
                  KeepWindowsAliveCallBackPr,
{$ENDIF}
                  TransfPtr, Sloupcu, Radku, JmenoNovehoSouboru, fSt, fN,
                  MinSSloupcuN, MaxSRadkuN, cSloupcuN, cRadkuN, SloupcuN, RadkuN, EscDone
                  {$IFNDEF Windows}, Procenta{$ENDIF});
    end
  else
    with TransfPtr^ do
    begin
{$IFDEF Windows}
      LoadString(HInstance, 621, Retezec1, 256);
      LoadString(HInstance, 622, Retezec2, 256);
      if (StrIComp(NazevTransformace, Retezec1{'PODOBN 2D'}) = 0) or
         (StrIComp(NazevTransformace, Retezec2{'AFINN  2D'}) = 0) then
{$ELSE}
      if (NazevTransformace = Vyb_Podobn2D{'PODOBN 2D'}) or (NazevTransformace = Vyb_Afinn2D{'AFINN  2D'}) then
{$ENDIF}
        Afin2FalseM(
{$IFDEF Windows}
                    DalsiKrokAbortNMCallBackPr,
                    BylUserAbortAbortNMCallBackPr,
                    KeepWindowsAliveCallBackPr,
{$ENDIF}
                    TransfPtr, Sloupcu, Radku, JmenoNovehoSouboru, fSt, fN,
                    MinSSloupcuN, MaxSRadkuN, cSloupcuN, cRadkuN, SloupcuN, RadkuN, EscDone
                    {$IFNDEF Windows}, Procenta{$ENDIF})
      else
        Ost2FalseM(
{$IFDEF Windows}
                   DalsiKrokAbortNMCallBackPr,
                   BylUserAbortAbortNMCallBackPr,
                   KeepWindowsAliveCallBackPr,
{$ENDIF}
                   TransfPtr, Sloupcu, Radku, JmenoNovehoSouboru, fSt, fN,
                   MinSSloupcuN, MaxSRadkuN, cSloupcuN, cRadkuN, SloupcuN, RadkuN, EscDone
                   {$IFNDEF Windows}, Procenta{$ENDIF});
    end;
end;




end.
